/*!
 * @jeff-js/element-ui v2.5.59
 * (c) 2018-2023 jeff
 * Github https://github.com/xaboy/form-create
 * Released under the MIT License.
 */
(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('vue')) :
    typeof define === 'function' && define.amd ? define(['exports', 'vue'], factory) :
    (global = global || self, factory(global.formCreate = {}, global.Vue));
}(this, (function (exports, Vue) { 'use strict';

    Vue = Vue && Object.prototype.hasOwnProperty.call(Vue, 'default') ? Vue['default'] : Vue;

    function _extends() {
      return _extends = Object.assign ? Object.assign.bind() : function (a) {
        for (var b, c = 1; c < arguments.length; c++) for (var d in b = arguments[c], b) Object.prototype.hasOwnProperty.call(b, d) && (a[d] = b[d]);
        return a;
      }, _extends.apply(this, arguments);
    }
    var normalMerge = ["attrs", "props", "domProps"],
      toArrayMerge = ["class", "style", "directives"],
      functionalMerge = ["on", "nativeOn"],
      mergeJsxProps = function (a) {
        return a.reduce(function (c, a) {
          for (var b in a) if (!c[b]) c[b] = a[b];else if (-1 !== normalMerge.indexOf(b)) c[b] = _extends({}, c[b], a[b]);else if (-1 !== toArrayMerge.indexOf(b)) {
            var d = c[b] instanceof Array ? c[b] : [c[b]],
              e = a[b] instanceof Array ? a[b] : [a[b]];
            c[b] = [].concat(d, e);
          } else if (-1 !== functionalMerge.indexOf(b)) {
            for (var f in a[b]) if (c[b][f]) {
              var g = c[b][f] instanceof Array ? c[b][f] : [c[b][f]],
                h = a[b][f] instanceof Array ? a[b][f] : [a[b][f]];
              c[b][f] = [].concat(g, h);
            } else c[b][f] = a[b][f];
          } else if ("hook" === b) for (var i in a[b]) c[b][i] = c[b][i] ? mergeFn(c[b][i], a[b][i]) : a[b][i];else c[b] = a[b];
          return c;
        }, {});
      },
      mergeFn = function (a, b) {
        return function () {
          a && a.apply(this, arguments), b && b.apply(this, arguments);
        };
      };
    var helper = mergeJsxProps;

    function getSlot(slots, exclude) {
      return Object.keys(slots).reduce((lst, name) => {
        if (!exclude || exclude.indexOf(name) === -1) {
          lst.push(slots[name]);
        }
        return lst;
      }, []);
    }

    const NAME = 'fcCheckbox';
    var Checkbox = {
      name: NAME,
      props: {
        formCreateInject: {
          type: Object,
          required: true
        },
        value: {
          type: Array,
          default: () => []
        },
        type: String
      },
      watch: {
        'formCreateInject.options': {
          handler() {
            this.update();
          },
          deep: true
        },
        value() {
          this.update();
        }
      },
      data() {
        return {
          trueValue: []
        };
      },
      methods: {
        options() {
          const opt = this.formCreateInject.options;
          return Array.isArray(opt) ? opt : [];
        },
        onInput(n) {
          this.$emit('input', this.options().filter(opt => n.indexOf(opt.label) !== -1).map(opt => opt.value).filter(v => v !== undefined));
        },
        update() {
          this.trueValue = this.value ? this.options().filter(opt => this.value.indexOf(opt.value) !== -1).map(option => option.label) : [];
        }
      },
      created() {
        this.update();
      },
      render() {
        const h = arguments[0];
        return h("ElCheckboxGroup", helper([{}, this.formCreateInject.prop, {}, {
          "props": {
            value: this.trueValue
          }
        }, {
          "on": {
            "input": this.onInput
          }
        }]), [this.options().map((opt, index) => {
          const props = {
            ...opt
          };
          const Type = this.type === 'button' ? 'ElCheckboxButton' : 'ElCheckbox';
          delete props.value;
          return h(Type, helper([{}, {
            "props": props
          }, {
            "key": Type + index + '-' + opt.value
          }]));
        }), getSlot(this.$slots)]);
      }
    };

    function toArray(value) {
      return Array.isArray(value) ? value : [null, undefined, ''].indexOf(value) > -1 ? [] : [value];
    }

    function styleInject(css, ref) {
      if (ref === void 0) ref = {};
      var insertAt = ref.insertAt;
      if (!css || typeof document === 'undefined') {
        return;
      }
      var head = document.head || document.getElementsByTagName('head')[0];
      var style = document.createElement('style');
      style.type = 'text/css';
      if (insertAt === 'top') {
        if (head.firstChild) {
          head.insertBefore(style, head.firstChild);
        } else {
          head.appendChild(style);
        }
      } else {
        head.appendChild(style);
      }
      if (style.styleSheet) {
        style.styleSheet.cssText = css;
      } else {
        style.appendChild(document.createTextNode(css));
      }
    }

    var css_248z = "._fc-frame .fc-files img {\n    width: 100%;\n    height: 100%;\n    display: inline-block;\n    vertical-align: top;\n}\n\n._fc-frame .fc-upload-btn {\n    border: 1px dashed #c0ccda;\n    cursor: pointer;\n}\n\n._fc-frame .fc-upload-cover {\n    opacity: 0;\n    position: absolute;\n    top: 0;\n    bottom: 0;\n    left: 0;\n    right: 0;\n    background: rgba(0, 0, 0, .6);\n    -webkit-transition: opacity .3s;\n    -o-transition: opacity .3s;\n    transition: opacity .3s;\n}\n\n._fc-frame .fc-upload-cover i {\n    color: #fff;\n    font-size: 20px;\n    cursor: pointer;\n    margin: 0 2px;\n}\n\n._fc-frame .fc-files:hover .fc-upload-cover {\n    opacity: 1;\n}\n\n._fc-frame .el-upload {\n    display: block;\n}";
    styleInject(css_248z);

    const NAME$1 = 'fcFrame';
    var Frame = {
      name: NAME$1,
      props: {
        formCreateInject: {
          type: Object,
          required: true
        },
        type: {
          type: String,
          default: 'input'
        },
        field: String,
        helper: {
          type: Boolean,
          default: true
        },
        disabled: {
          type: Boolean,
          default: false
        },
        src: {
          type: String,
          required: true
        },
        icon: {
          type: String,
          default: 'el-icon-upload2'
        },
        width: {
          type: String,
          default: '500px'
        },
        height: {
          type: String,
          default: '370px'
        },
        maxLength: {
          type: Number,
          default: 0
        },
        okBtnText: {
          type: String,
          default: '确定'
        },
        closeBtnText: {
          type: String,
          default: '关闭'
        },
        modalTitle: String,
        handleIcon: {
          type: [String, Boolean],
          default: undefined
        },
        title: String,
        allowRemove: {
          type: Boolean,
          default: true
        },
        onOpen: {
          type: Function,
          default: () => {}
        },
        onOk: {
          type: Function,
          default: () => {}
        },
        onCancel: {
          type: Function,
          default: () => {}
        },
        onLoad: {
          type: Function,
          default: () => {}
        },
        onBeforeRemove: {
          type: Function,
          default: () => {}
        },
        onRemove: {
          type: Function,
          default: () => {}
        },
        onHandle: {
          type: Function,
          default(src) {
            this.previewImage = this.getSrc(src);
            this.previewVisible = true;
          }
        },
        modal: {
          type: Object,
          default: () => ({})
        },
        srcKey: {
          type: [String, Number]
        },
        value: [Array, String, Number, Object],
        previewMask: undefined,
        footer: {
          type: Boolean,
          default: true
        },
        reload: {
          type: Boolean,
          default: true
        },
        closeBtn: {
          type: Boolean,
          default: true
        },
        okBtn: {
          type: Boolean,
          default: true
        }
      },
      data() {
        return {
          fileList: toArray(this.value),
          previewVisible: false,
          frameVisible: false,
          previewImage: ''
        };
      },
      watch: {
        value(n) {
          this.fileList = toArray(n);
        },
        fileList(n) {
          const val = this.maxLength === 1 ? n[0] || '' : n;
          this.$emit('input', val);
          this.$emit('change', val);
        },
        src(n) {
          this.modalVm && (this.modalVm.src = n);
        }
      },
      methods: {
        key(unique) {
          return unique;
        },
        closeModel(close) {
          this.$emit(close ? '$close' : '$ok');
          if (this.reload) {
            this.$off('$ok');
            this.$off('$close');
          }
          this.frameVisible = false;
        },
        handleCancel() {
          this.previewVisible = false;
        },
        showModel() {
          if (this.disabled || false === this.onOpen()) {
            return;
          }
          this.frameVisible = true;
        },
        makeInput() {
          const h = this.$createElement;
          const props = {
            type: 'text',
            value: this.fileList.map(v => this.getSrc(v)).toString(),
            readonly: true
          };
          return h("ElInput", helper([{}, {
            "props": props
          }, {
            "key": this.key('input')
          }]), [this.fileList.length ? h("i", {
            "slot": "suffix",
            "class": "el-input__icon el-icon-circle-close",
            "on": {
              "click": () => this.fileList = []
            }
          }) : null, h("ElButton", helper([{
            "attrs": {
              "icon": this.icon
            }
          }, {
            "on": {
              'click': () => this.showModel()
            }
          }, {
            "slot": "append"
          }]))]);
        },
        makeGroup(children) {
          const h = this.$createElement;
          if (!this.maxLength || this.fileList.length < this.maxLength) {
            children.push(this.makeBtn());
          }
          return h("div", {
            "key": this.key('group')
          }, [...children]);
        },
        makeItem(index, children) {
          const h = this.$createElement;
          return h("div", {
            "class": 'fc-files',
            "key": this.key('file' + index)
          }, [...children]);
        },
        valid(f) {
          const field = this.formCreateInject.field || this.field;
          if (field && f !== field) {
            throw new Error('[frame]无效的字段值');
          }
        },
        makeIcons(val, index) {
          const h = this.$createElement;
          if (this.handleIcon !== false || this.allowRemove === true) {
            const icons = [];
            if (this.type !== 'file' && this.handleIcon !== false || this.type === 'file' && this.handleIcon) {
              icons.push(this.makeHandleIcon(val, index));
            }
            if (this.allowRemove) {
              icons.push(this.makeRemoveIcon(val, index));
            }
            return h("div", {
              "class": 'fc-upload-cover',
              "key": this.key('uc')
            }, [icons]);
          }
        },
        makeHandleIcon(val, index) {
          const h = this.$createElement;
          return h("i", {
            "class": this.handleIcon === true || this.handleIcon === undefined ? 'el-icon-view' : this.handleIcon,
            "on": {
              "click": () => this.handleClick(val)
            },
            "key": this.key('hi' + index)
          });
        },
        makeRemoveIcon(val, index) {
          const h = this.$createElement;
          return h("i", {
            "class": "el-icon-delete",
            "on": {
              "click": () => this.handleRemove(val)
            },
            "key": this.key('ri' + index)
          });
        },
        makeFiles() {
          const h = this.$createElement;
          return this.makeGroup(this.fileList.map((src, index) => {
            return this.makeItem(index, [h("i", {
              "class": "el-icon-tickets",
              "on": {
                "click": () => this.handleClick(src)
              }
            }), this.makeIcons(src, index)]);
          }));
        },
        makeImages() {
          const h = this.$createElement;
          return this.makeGroup(this.fileList.map((src, index) => {
            return this.makeItem(index, [h("img", {
              "attrs": {
                "src": this.getSrc(src)
              }
            }), this.makeIcons(src, index)]);
          }));
        },
        makeBtn() {
          const h = this.$createElement;
          return h("div", {
            "class": 'fc-upload-btn',
            "on": {
              "click": () => this.showModel()
            },
            "key": this.key('btn')
          }, [h("i", {
            "class": this.icon
          })]);
        },
        handleClick(src) {
          return this.onHandle(src);
        },
        handleRemove(src) {
          if (this.disabled) {
            return;
          }
          if (false !== this.onBeforeRemove(src)) {
            this.fileList.splice(this.fileList.indexOf(src), 1);
            this.onRemove(src);
          }
        },
        getSrc(src) {
          return !this.srcKey ? src : src[this.srcKey];
        },
        frameLoad(iframe) {
          this.onLoad(iframe);
          try {
            if (this.helper === true) {
              iframe['form_create_helper'] = {
                api: this.formCreateInject.api,
                close: field => {
                  this.valid(field);
                  this.closeModel();
                },
                set: (field, value) => {
                  this.valid(field);
                  if (!this.disabled) this.$emit('input', value);
                },
                get: field => {
                  this.valid(field);
                  return this.value;
                },
                onOk: fn => this.$on('$ok', fn),
                onClose: fn => this.$on('$close', fn)
              };
            }
          } catch (e) {
            console.log(e);
          }
        },
        makeFooter() {
          const h = this.$createElement;
          const {
            okBtnText,
            closeBtnText,
            closeBtn,
            okBtn,
            footer
          } = this.$props;
          if (!footer) {
            return;
          }
          return h("div", {
            "slot": "footer"
          }, [closeBtn ? h("ElButton", {
            "on": {
              "click": () => this.onCancel() !== false && (this.frameVisible = false)
            }
          }, [closeBtnText]) : null, okBtn ? h("ElButton", {
            "attrs": {
              "type": "primary"
            },
            "on": {
              "click": () => this.onOk() !== false && this.closeModel()
            }
          }, [okBtnText]) : null]);
        }
      },
      render() {
        const h = arguments[0];
        const type = this.type;
        let node;
        if (type === 'input') {
          node = this.makeInput();
        } else if (type === 'image') {
          node = this.makeImages();
        } else {
          node = this.makeFiles();
        }
        const {
          width = '30%',
          height,
          src,
          title,
          modalTitle
        } = this.$props;
        this.$nextTick(() => {
          if (this.$refs.frame) {
            this.frameLoad(this.$refs.frame.contentWindow || {});
          }
        });
        return h("div", {
          "class": "_fc-frame"
        }, [node, h("el-dialog", helper([{}, {
          "props": {
            appendToBody: true,
            modal: this.previewMask,
            title: modalTitle,
            visible: this.previewVisible
          }
        }, {
          "on": {
            "close": this.handleCancel
          }
        }]), [h("img", {
          "style": "width: 100%",
          "attrs": {
            "src": this.previewImage
          }
        })]), h("el-dialog", helper([{}, {
          "props": {
            width,
            title,
            appendToBody: true,
            ...this.modal,
            visible: this.frameVisible
          }
        }, {
          "on": {
            "close": () => this.closeModel(true)
          }
        }]), [this.frameVisible || !this.reload ? h("iframe", {
          "ref": "frame",
          "attrs": {
            "src": src,
            "frameBorder": "0"
          },
          "style": {
            'height': height,
            'border': '0 none',
            'width': '100%'
          }
        }) : null, this.makeFooter()])]);
      },
      mounted() {
        this.$on('fc.closeModal', this.closeModal);
      }
    };

    const NAME$2 = 'fcRadio';
    var Radio = {
      name: NAME$2,
      props: {
        formCreateInject: {
          type: Object,
          required: true
        },
        value: {},
        type: String
      },
      watch: {
        'formCreateInject.options': {
          handler() {
            this.update();
          },
          deep: true
        },
        value() {
          this.update();
        }
      },
      data() {
        return {
          trueValue: []
        };
      },
      methods: {
        options() {
          const opt = this.formCreateInject.options;
          return Array.isArray(opt) ? opt : [];
        },
        onInput(n) {
          this.$emit('input', this.options().filter(opt => opt.label === n).reduce((initial, opt) => opt.value, ''));
        },
        update() {
          this.trueValue = this.options().filter(opt => opt.value === this.value).reduce((initial, opt) => opt.label, '');
        }
      },
      created() {
        this.update();
      },
      render() {
        const h = arguments[0];
        return h("ElRadioGroup", helper([{}, this.formCreateInject.prop, {}, {
          "props": {
            value: this.trueValue
          }
        }, {
          "on": {
            "input": this.onInput
          }
        }]), [this.options().map((opt, index) => {
          const props = {
            ...opt
          };
          const Type = this.type === 'button' ? 'ElRadioButton' : 'ElRadio';
          delete props.value;
          return h(Type, helper([{}, {
            "props": props
          }, {
            "key": Type + index + '-' + opt.value
          }]));
        }), getSlot(this.$slots)]);
      }
    };

    const is = {
      type(arg, type) {
        return Object.prototype.toString.call(arg) === '[object ' + type + ']';
      },
      Undef(v) {
        return v === undefined || v === null;
      },
      Element(arg) {
        return typeof arg === 'object' && arg !== null && arg.nodeType === 1 && !is.Object(arg);
      },
      trueArray(data) {
        return Array.isArray(data) && data.length > 0;
      },
      Function(v) {
        const type = this.getType(v);
        return type === 'Function' || type === 'AsyncFunction';
      },
      getType(v) {
        const str = Object.prototype.toString.call(v);
        return /^\[object (.*)\]$/.exec(str)[1];
      },
      empty(value) {
        if (value === undefined || value === null) {
          return true;
        }
        if (Array.isArray(value) && Array.isArray(value) && !value.length) {
          return true;
        }
        return typeof value === 'string' && !value;
      }
    };
    ['Date', 'Object', 'String', 'Boolean', 'Array', 'Number'].forEach(t => {
      is[t] = function (arg) {
        return is.type(arg, t);
      };
    });
    function hasProperty(rule, k) {
      return {}.hasOwnProperty.call(rule, k);
    }

    const NAME$3 = 'fcSelect';
    var Select = {
      name: NAME$3,
      functional: true,
      props: {
        formCreateInject: {
          type: Object,
          required: true
        }
      },
      render(h, ctx) {
        const options = ctx.props.formCreateInject.options;
        const {
          value
        } = ctx.data;
        if (!Array.isArray(value)) {
          ctx.data.value = [value];
        }
        return h("ElSelect", helper([{}, ctx.data]), [(Array.isArray(options) ? options : []).map((props, index) => {
          const slot = props.slot;
          return h("ElOption", helper([{}, {
            "props": props
          }, {
            "key": '' + index + '-' + props.value
          }]), [slot ? h("template", {
            "slot": props.slotName || 'default'
          }, [is.Function(slot) ? props.slot(h) : slot]) : null]);
        }), ctx.children]);
      }
    };

    const NAME$4 = 'fcTree';
    var Tree = {
      name: NAME$4,
      formCreateParser: {
        mergeProp(ctx) {
          const props = ctx.prop.props;
          if (!props.nodeKey) props.nodeKey = 'id';
          if (!props.props) props.props = {
            label: 'title'
          };
        }
      },
      props: {
        formCreateInject: {
          type: Object,
          required: true
        },
        type: {
          type: String,
          default: 'checked'
        },
        value: {
          type: [Array, String, Number],
          default: () => []
        }
      },
      watch: {
        value() {
          this.setValue();
        }
      },
      methods: {
        onChange() {
          this.updateValue();
        },
        updateValue() {
          if (!this.$refs.tree) return;
          const type = this.type.toLocaleLowerCase();
          let value;
          if (type === 'selected') {
            value = this.$refs.tree.getCurrentKey();
          } else {
            value = this.$refs.tree.getCheckedKeys();
          }
          this.$emit('input', value);
        },
        setValue() {
          const type = this.type.toLocaleLowerCase();
          if (type === 'selected') {
            this.$refs.tree.setCurrentKey(this.value);
          } else {
            this.$refs.tree.setCheckedKeys(toArray(this.value));
          }
        }
      },
      render() {
        const h = arguments[0];
        return h("ElTree", helper([{}, this.formCreateInject.prop, {
          "ref": "tree",
          "on": {
            "check": () => this.updateValue(),
            "node-click": () => this.updateValue()
          }
        }]), [getSlot(this.$slots)]);
      },
      mounted() {
        this.setValue();
      }
    };

    var css_248z$1 = "._fc-upload-file {\n    display: flex;\n    flex-direction: column;\n    align-items: flex-start;\n}\n._fc-upload-file .el-upload-button-container{\n    line-height: 1;\n    margin-bottom: 10px;\n}\n._fc-upload-file .el-upload-button-container.is_hidden{\n    height: 0;\n    margin: 0;\n    opacity: 0;\n}\n._fc-upload-file .upload__tip{\n    font-size: 12px;\n    color: #606266;\n    line-height: inherit;\n    margin-bottom: 6px;\n}\n._fc-upload-file .fc-upload-btn{\n    margin-bottom: 6px;\n}\n._fc-upload-file .fc-upload-btn i{\n    margin-right: 3px;\n}\n._fc-upload-file .fc-upload-btn .el-button{\n    background: #EBF3FE;\n    color: #3F8Eff;\n    border: 0;\n}\n._fc-upload-file .fc-files{\n    display: flex !important;\n    align-items: center;\n    padding: 0 6px;\n    line-height: 30px;\n    margin-bottom: 4px;\n    border-radius: 4px;\n    width: auto;\n    border: none;\n    box-shadow: none;\n    height: 30px;\n}\n._fc-upload-file .fc-files:hover{\n    background: #f4f9fd;\n}\n._fc-upload-file .file-prefix-icon{\n    margin-right: 8px;\n}\n._fc-upload-file .fc-files img {\n    width: 100%;\n    height: 100%;\n    display: inline-block;\n    vertical-align: top;\n}\n\n._fc-upload-file .fc-upload-btn {\n    cursor: pointer;\n}\n\n._fc-upload-file .fc-upload-cover {\n    color: #000;\n    -webkit-transition: opacity .3s;\n    -o-transition: opacity .3s;\n    transition: opacity .3s;\n}\n\n._fc-upload-file .fc-upload-cover i {\n    color: #000;\n    font-size: 16px;\n    cursor: pointer;\n    margin-left: 30px;\n}\n\n._fc-upload-file .fc-files .file-item a{\n   color: #409EFF;\n   text-decoration: underline; \n   cursor: pointer;\n}\n\n._fc-upload-file .fc-files:hover .fc-upload-cover {\n    opacity: 1;\n}\n\n._fc-upload-file .el-upload {\n    display: block;\n}\n\n._fc-upload-file .fc-upload-btn, ._fc-upload-file .fc-files {\n    display: inline-block;\n    text-align: center;\n    overflow: hidden;\n    position: relative;\n    margin-right: 4px;\n    -webkit-box-sizing: border-box;\n    box-sizing: border-box;\n}\n";
    styleInject(css_248z$1);

    function parseFile(file, i) {
      if (file.name) return file;
      return {
        url: '/api/file/download/' + file.uuid,
        name: file.fileName,
        uid: i
      };
    }
    const NAME$5 = 'fcUpload';
    var Upload = {
      name: NAME$5,
      props: {
        formCreateInject: {
          type: Object,
          required: true
        },
        onHandle: {
          type: Function,
          default(file) {
            this.previewImage = file.url;
            this.previewVisible = true;
          }
        },
        uploadType: {
          type: String,
          default: 'file'
        },
        limit: {
          type: Number,
          default: 0
        },
        allowRemove: {
          type: Boolean,
          default: true
        },
        previewMask: undefined,
        modalTitle: String,
        handleIcon: {
          type: [String, Boolean],
          default: () => undefined
        },
        value: [Array, String],
        tip: String,
        allowUpload: {
          type: Boolean,
          default: true
        }
      },
      data() {
        return {
          uploadList: [],
          previewVisible: false,
          previewImage: '',
          cacheFiles: []
        };
      },
      created() {
        if (this.formCreateInject.prop.props.showFileList === undefined) {
          this.formCreateInject.prop.props.showFileList = false;
        }
      },
      watch: {
        value(n) {
          if (this.$refs.upload.uploadFiles.every(file => {
            return !file.status || file.status === 'success';
          })) {
            console.log('watch：value', n);
            this.$refs.upload.uploadFiles = n.map(parseFile);
            this.uploadList = this.$refs.upload.uploadFiles;
          }
        },
        limit(n, o) {
          if (o === 1 || n === 1) {
            this.update();
          }
        }
      },
      methods: {
        key(unique) {
          return unique;
        },
        isDisabled() {
          return this.formCreateInject.prop.props.disabled === true;
        },
        onRemove(file) {
          if (this.isDisabled()) {
            return;
          }
          this.$refs.upload.handleRemove(file);
        },
        handleClick(file) {
          this.onHandle(file);
        },
        makeItem(file, index) {
          const h = this.$createElement;
          if (this.uploadType === 'image') {
            return h("img", {
              "attrs": {
                "src": file.url
              },
              "key": this.key('img' + index)
            });
          } else {
            return h("div", {
              "class": 'file-item'
            }, [h("a", {
              "attrs": {
                "href": file.url,
                "target": '_blank'
              }
            }, [file.name])]);
          }
        },
        makeRemoveIcon(file, index) {
          const h = this.$createElement;
          return h("i", {
            "class": "el-icon-delete",
            "on": {
              "click": () => this.onRemove(file)
            },
            "key": this.key('ri' + index)
          });
        },
        makeHandleIcon(file, index) {
          const h = this.$createElement;
          return h("i", {
            "class": this.handleIcon === true || this.handleIcon === undefined ? 'el-icon-view' : this.handleIcon,
            "on": {
              "click": () => this.handleClick(file)
            },
            "key": this.key('hi' + index)
          });
        },
        makeProgress(file, index) {
          const h = this.$createElement;
          return h("el-progress", {
            "style": "width:200px",
            "attrs": {
              "percentage": file.percentage,
              "status": "success"
            },
            "key": this.key('pg' + index)
          });
        },
        makeIcons(file, index) {
          const h = this.$createElement;
          const icons = [];
          if (this.allowRemove || this.handleIcon !== false) {
            if (this.uploadType !== 'file' && this.handleIcon !== false || this.uploadType === 'file' && this.handleIcon) {
              icons.push(this.makeHandleIcon(file, index));
            }
            if (this.allowRemove) {
              icons.push(this.makeRemoveIcon(file, index));
            }
            return h("div", {
              "class": 'fc-upload-cover'
            }, [icons]);
          }
        },
        makeFiles() {
          const h = this.$createElement;
          return this.uploadList.map((file, index) => this.$scopedSlots.fileList ? this.$scopedSlots.fileList({
            file,
            index,
            vm: this
          }) : h("div", {
            "key": this.key(index),
            "class": 'fc-files'
          }, [h("i", {
            "class": "file-prefix-icon el-icon-document"
          }), file.percentage !== undefined && file.status !== 'success' ? this.makeProgress(file, index) : [this.makeItem(file, index), this.makeIcons(file, index)]]));
        },
        makeUpload() {
          const h = this.$createElement;
          const isShow = !this.limit || this.limit > this.uploadList.length;
          const allowUpload = isShow && this.allowUpload;
          return h("div", {
            "class": allowUpload ? 'el-upload-button-container' : 'el-upload-button-container is_hidden'
          }, [h("ElUpload", helper([{}, this.formCreateInject.prop, {
            "ref": "upload",
            "style": {
              display: 'inline-block'
            },
            "key": this.key('upload')
          }]), [allowUpload ? h("template", {
            "slot": "default"
          }, [this.$slots.default || h("div", {
            "class": 'fc-upload-btn'
          }, [h("el-button", {
            "attrs": {
              "type": "primary",
              "size": "small"
            }
          }, [h("i", {
            "class": "el-icon-upload el-icon--right"
          }), "\u4E0A\u4F20"])])]) : null, getSlot(this.$slots, ['default'])]), this.tip && this.allowUpload ? h("div", {
            "class": "upload__tip"
          }, [this.tip]) : null]);
        },
        update() {
          console.log('update', this.$refs.upload.uploadFiles);
          let files = this.$refs.upload.uploadFiles.filter(url => url !== undefined);
          if (this.cacheFiles.length !== files.length) {
            this.cacheFiles = [...files];
            this.$emit('input', this.limit === 1 ? files[0] || '' : files);
          }
        },
        handleCancel() {
          this.previewVisible = false;
        }
      },
      render() {
        const h = arguments[0];
        if (this.$refs.upload) {
          if (this.formCreateInject.prop.props.showFileList === undefined) {
            this.formCreateInject.prop.props.showFileList = this.$refs.upload.showFileList;
          }
          this.formCreateInject.prop.props.fileList = this.$refs.upload.fileList;
        }
        return h("div", {
          "class": '_fc-upload-file test'
        }, [[this.makeUpload(), this.formCreateInject.prop.props.showFileList ? [] : this.makeFiles()], h("el-dialog", helper([{}, {
          "props": {
            appendToBody: true,
            modal: this.previewMask,
            title: this.modalTitle,
            visible: this.previewVisible
          }
        }, {
          "on": {
            "close": this.handleCancel
          }
        }]), [h("img", {
          "attrs": {
            "alt": "example",
            "src": this.previewImage
          },
          "style": "width: 100%"
        })])]);
      },
      mounted() {
        this.uploadList = this.$refs.upload.uploadFiles;
        this.$watch(() => this.$refs.upload.uploadFiles, () => {
          this.update();
        }, {
          deep: true
        });
      }
    };

    function $set(target, field, value) {
      Vue.set(target, field, value);
    }
    function $del(target, field) {
      Vue.delete(target, field);
    }

    function deepExtend(origin, target = {}, mode) {
      let isArr = false;
      for (let key in target) {
        if (Object.prototype.hasOwnProperty.call(target, key)) {
          let clone = target[key];
          if ((isArr = Array.isArray(clone)) || is.Object(clone)) {
            let nst = origin[key] === undefined;
            if (isArr) {
              isArr = false;
              nst && $set(origin, key, []);
            } else if (clone._clone && mode !== undefined) {
              if (mode) {
                clone = clone.getRule();
                nst && $set(origin, key, {});
              } else {
                $set(origin, key, clone._clone());
                continue;
              }
            } else {
              nst && $set(origin, key, {});
            }
            origin[key] = deepExtend(origin[key], clone, mode);
          } else {
            $set(origin, key, clone);
            if (!is.Undef(clone)) {
              if (!is.Undef(clone.__json)) {
                origin[key].__json = clone.__json;
              }
              if (!is.Undef(clone.__origin)) {
                origin[key].__origin = clone.__origin;
              }
            }
          }
        }
      }
      return mode !== undefined && Array.isArray(origin) ? origin.filter(v => !v || !v.__ctrl) : origin;
    }
    function deepCopy(value) {
      return deepExtend({}, {
        value
      }).value;
    }

    const _extends$1 = Object.assign || function (a) {
      for (let b, c = 1; c < arguments.length; c++) {
        for (let d in b = arguments[c], b) {
          Object.prototype.hasOwnProperty.call(b, d) && $set(a, d, b[d]);
        }
      }
      return a;
    };
    function extend() {
      return _extends$1.apply(this, arguments);
    }

    const NAME$6 = 'fcGroup';
    var Group = {
      name: NAME$6,
      props: {
        field: String,
        rule: [Array, Object],
        rules: Array,
        expand: Number,
        options: Object,
        formCreateInject: {
          type: Object,
          required: true
        },
        button: {
          type: Boolean,
          default: true
        },
        max: {
          type: Number,
          default: 0
        },
        min: {
          type: Number,
          default: 0
        },
        value: {
          type: Array,
          default: () => []
        },
        defaultValue: Object,
        disabled: {
          type: Boolean,
          default: false
        },
        syncDisabled: {
          type: Boolean,
          default: true
        },
        fontSize: {
          type: Number,
          default: 28
        },
        onBeforeRemove: {
          type: Function,
          default: () => {}
        },
        onBeforeAdd: {
          type: Function,
          default: () => {}
        }
      },
      data() {
        return {
          len: 0,
          cacheRule: {},
          cacheValue: {},
          type: undefined
        };
      },
      computed: {
        formRule() {
          if (this.rules) {
            return this.rules;
          }
          if (this.rule) {
            return Array.isArray(this.rule) ? this.rule : [this.rule];
          }
          return [];
        }
      },
      watch: {
        formRule: {
          handler(n, o) {
            Object.keys(this.cacheRule).forEach(v => {
              const item = this.cacheRule[v];
              if (item.$f) {
                const val = item.$f.formData();
                if (n === o) {
                  item.$f.deferSyncValue(() => {
                    deepExtend(item.rule, n);
                    item.$f.setValue(val);
                  }, true);
                } else {
                  const val = item.$f.formData();
                  item.$f.once('reloading', () => {
                    item.$f.setValue(val);
                  });
                  item.rule = deepCopy(n);
                }
              }
            });
          },
          deep: true
        },
        disabled(n) {
          if (this.syncDisabled) {
            const lst = this.cacheRule;
            Object.keys(lst).forEach(k => {
              lst[k].$f.disabled(n);
            });
          }
        },
        expand(n) {
          let d = n - this.value.length;
          if (d > 0) {
            this.expandRule(d);
          }
        },
        value(n) {
          n = n || [];
          let keys = Object.keys(this.cacheRule),
            total = keys.length,
            len = total - n.length;
          if (len < 0) {
            for (let i = len; i < 0; i++) {
              this.addRule(n.length + i);
            }
            for (let i = 0; i < total; i++) {
              this.setValue(keys[i], n[i]);
            }
          } else {
            if (len > 0) {
              for (let i = 0; i < len; i++) {
                this.removeRule(keys[total - i - 1]);
              }
            }
            n.forEach((val, i) => {
              this.setValue(keys[i], n[i]);
            });
          }
        }
      },
      methods: {
        _value(v) {
          return v && hasProperty(v, this.field) ? v[this.field] : v;
        },
        cache(k, val) {
          this.cacheValue[k] = JSON.stringify(val);
        },
        input(value) {
          this.$emit('input', value);
          this.$emit('change', value);
        },
        formData(key, formData) {
          const cacheRule = this.cacheRule;
          const keys = Object.keys(cacheRule);
          if (keys.filter(k => cacheRule[k].$f).length !== keys.length) {
            return;
          }
          const value = keys.map(k => {
            const data = key === k ? formData : {
              ...this.cacheRule[k].$f.form
            };
            const value = this.field ? data[this.field] || null : data;
            this.cache(k, value);
            return value;
          });
          this.input(value);
        },
        setValue(key, value) {
          const field = this.field,
            $f = this.cacheRule[key].$f;
          if (field) {
            value = {
              [field]: this._value(value)
            };
          }
          if (this.cacheValue[key] === JSON.stringify(field ? value[field] : value)) {
            return;
          }
          this.cache(key, value);
          $f.coverValue(value || {});
        },
        addRule(i, emit) {
          const rule = this.formCreateInject.form.copyRules(this.formRule);
          const options = this.options ? {
            ...this.options
          } : {
            submitBtn: false,
            resetBtn: false
          };
          if (this.defaultValue) {
            if (!options.formData) options.formData = {};
            const defVal = deepCopy(this.defaultValue);
            extend(options.formData, this.field ? {
              [this.field]: defVal
            } : defVal);
          }
          this.$set(this.cacheRule, ++this.len, {
            rule,
            options
          });
          if (emit) {
            this.$nextTick(() => this.$emit('add', rule, Object.keys(this.cacheRule).length - 1));
          }
        },
        add$f(i, key, $f) {
          this.cacheRule[key].$f = $f;
          this.formData(key, $f.formData());
          this.$nextTick(() => {
            if (this.syncDisabled) {
              $f.disabled(this.disabled);
            }
            this.$emit('itemMounted', $f, Object.keys(this.cacheRule).indexOf(key));
          });
        },
        removeRule(key, emit) {
          const index = Object.keys(this.cacheRule).indexOf(key);
          this.$delete(this.cacheRule, key);
          this.$delete(this.cacheValue, key);
          if (emit) {
            this.$nextTick(() => this.$emit('remove', index));
          }
        },
        add(i) {
          if (this.disabled || false === this.onBeforeAdd(this.value)) {
            return;
          }
          this.addRule(i, true);
        },
        del(index, key) {
          if (this.disabled || false === this.onBeforeRemove(this.value, index)) {
            return;
          }
          this.removeRule(key, true);
          this.value.splice(index, 1);
          this.input(this.value);
        },
        addIcon(key) {
          const h = this.$createElement;
          return h("i", {
            "key": `a${key}`,
            "class": "el-icon-circle-plus-outline",
            "style": `font-size:${this.fontSize}px;cursor:${this.disabled ? 'not-allowed;color:#c9cdd4' : 'pointer'};`,
            "on": {
              "click": this.add
            }
          });
        },
        delIcon(index, key) {
          const h = this.$createElement;
          return h("i", {
            "key": `d${key}`,
            "class": "el-icon-remove-outline",
            "style": `font-size:${this.fontSize}px;cursor:${this.disabled ? 'not-allowed;color:#c9cdd4' : 'pointer;color:#606266'};`,
            "on": {
              "click": () => this.del(index, key)
            }
          });
        },
        makeIcon(total, index, key) {
          if (this.$scopedSlots.button) {
            return this.$scopedSlots.button({
              total,
              index,
              vm: this,
              key,
              del: () => this.del(index, key),
              add: this.add
            });
          }
          if (index === 0) {
            return [this.max !== 0 && total >= this.max ? null : this.addIcon(key), this.min === 0 || total > this.min ? this.delIcon(index, key) : null];
          }
          if (total > this.min) {
            return this.delIcon(index, key);
          }
        },
        emitEvent(name, args, index, key) {
          this.$emit(name, ...args, this.cacheRule[key].$f, index);
        },
        expandRule(n) {
          for (let i = 0; i < n; i++) {
            this.value.push(this.field ? null : {});
          }
        }
      },
      created() {
        this.type = this.formCreateInject.form.$form();
        const d = (this.expand || 0) - this.value.length;
        if (d > 0) {
          this.expandRule(d);
        }
        for (let i = 0; i < this.value.length; i++) {
          this.addRule(i);
        }
      },
      render() {
        const h = arguments[0];
        const keys = Object.keys(this.cacheRule);
        const button = this.button;
        const Type = this.type;
        return keys.length === 0 ? this.$scopedSlots.default ? this.$scopedSlots.default({
          vm: this,
          add: this.add
        }) : h("i", {
          "key": 'a_def',
          "class": "el-icon-circle-plus-outline",
          "style": `font-size:${this.fontSize}px;vertical-align:middle;color:${this.disabled ? '#c9cdd4;cursor: not-allowed' : '#606266;cursor:pointer'};`,
          "on": {
            "click": this.add
          }
        }) : h("div", {
          "key": 'con'
        }, [keys.map((key, index) => {
          const {
            rule,
            options
          } = this.cacheRule[key];
          return h("ElRow", {
            "attrs": {
              "align": "middle",
              "type": "flex"
            },
            "key": key,
            "style": "border-bottom:1px dashed #DCDFE6;margin-bottom:10px;"
          }, [h("ElCol", {
            "attrs": {
              "span": button ? 20 : 24
            }
          }, [h(Type, helper([{
            "key": key
          }, {
            "on": {
              'update:value': formData => this.formData(key, formData),
              'emit-event': (name, ...args) => this.emitEvent(name, args, index, key),
              input: $f => this.add$f(index, key, $f)
            }
          }, {}, {
            "props": {
              value: this.field ? {
                [this.field]: this._value(this.value[index])
              } : this.value[index],
              rule,
              option: options,
              extendOption: true,
              inFor: true
            }
          }]))]), button ? h("ElCol", helper([{}, {
            "props": {
              span: 2,
              pull: 1,
              push: 1
            }
          }]), [this.makeIcon(keys.length, index, key)]) : null]);
        })]);
      }
    };

    const NAME$7 = 'fcSubForm';
    var Sub = {
      name: NAME$7,
      props: {
        rule: Array,
        options: Object,
        formCreateInject: {
          type: Object,
          required: true
        },
        value: {
          type: Object,
          default: () => ({})
        },
        disabled: {
          type: Boolean,
          default: false
        },
        syncDisabled: {
          type: Boolean,
          default: true
        }
      },
      data() {
        return {
          cacheRule: {},
          cacheValue: {},
          type: undefined
        };
      },
      watch: {
        disabled(n) {
          this.syncDisabled && this.cacheRule.$f.disabled(n);
        },
        value(n) {
          this.setValue(n);
        }
      },
      methods: {
        formData(value) {
          this.cacheValue = JSON.stringify(value);
          this.$emit('input', value);
          this.$emit('change', value);
        },
        setValue(value) {
          const str = JSON.stringify(value);
          if (this.cacheValue === str) {
            return;
          }
          this.cacheValue = str;
          this.cacheRule.$f.coverValue(value || {});
        },
        addRule() {
          const options = this.options ? this.options : {
            submitBtn: false,
            resetBtn: false
          };
          options.formData = {
            ...(this.value || {})
          };
          this.cacheRule = {
            rule: this.rule,
            options
          };
        },
        add$f($f) {
          this.cacheRule.$f = $f;
          this.$nextTick(() => {
            this.syncDisabled && $f.disabled(this.disabled);
            this.$emit('itemMounted', $f);
          });
        },
        emitEvent(name, ...args) {
          this.$emit(name, ...args);
        }
      },
      created() {
        this.addRule();
        this.type = this.formCreateInject.form.$form();
      },
      render() {
        const h = arguments[0];
        const {
          rule,
          options
        } = this.cacheRule;
        const Type = this.type;
        return h(Type, helper([{}, {
          "on": {
            'update:value': this.formData,
            'emit-event': this.emitEvent,
            input: this.add$f
          }
        }, {}, {
          "props": {
            rule,
            option: options,
            extendOption: true
          }
        }]));
      }
    };

    var components = [Checkbox, Frame, Radio, Select, Tree, Upload, Group, Sub];

    const NAME$8 = 'FormCreate';
    const getRuleInject = (vm, parent) => {
      if (!vm || vm === parent) {
        return;
      }
      if (vm.formCreateInject) {
        return vm.formCreateInject;
      }
      if (vm.$parent) {
        return getRuleInject(vm.$parent, parent);
      }
    };
    function $FormCreate(FormCreate) {
      return {
        name: NAME$8,
        componentName: NAME$8,
        model: {
          prop: 'api'
        },
        provide() {
          return {
            $pfc: this
          };
        },
        inject: {
          $pfc: {
            default: null
          }
        },
        props: {
          rule: {
            type: Array,
            required: true
          },
          option: {
            type: Object,
            default: () => {
              return {};
            }
          },
          extendOption: Boolean,
          value: Object,
          api: Object,
          name: String,
          subForm: {
            type: Boolean,
            default: true
          },
          inFor: Boolean
        },
        data() {
          return {
            formData: undefined,
            destroyed: false,
            validate: {},
            $f: undefined,
            isShow: true,
            unique: 1,
            renderRule: [...(this.rule || [])],
            ctxInject: {},
            updateValue: JSON.stringify(this.value || {}),
            isMore: !!this.inFor
          };
        },
        render() {
          return this.formCreate.render();
        },
        methods: {
          _refresh() {
            ++this.unique;
          },
          _renderRule() {
            this.renderRule = [...(this.rule || [])];
          },
          _updateValue(value) {
            if (this.destroyed) return;
            this.updateValue = JSON.stringify(value);
            this.$emit('update:value', value);
          }
        },
        watch: {
          value: {
            handler(n) {
              if (JSON.stringify(n || {}) === this.updateValue) return;
              this.$f.config.forceCoverValue ? this.$f.coverValue(n || {}) : this.$f.setValue(n || {});
            },
            deep: true
          },
          option: {
            handler(n) {
              this.formCreate.initOptions(n);
              this.$f.refresh();
            },
            deep: true
          },
          rule(n) {
            if (n.length === this.renderRule.length && n.every(v => this.renderRule.indexOf(v) > -1)) return;
            this.formCreate.$handle.reloadRule(n);
            this._renderRule();
          }
        },
        beforeCreate() {
          const {
            rule,
            option
          } = this.$options.propsData;
          this.formCreate = new FormCreate(this, rule, option);
          Object.keys(this.formCreate.prop).forEach(k => {
            extend(this.$options[k], this.formCreate.prop[k]);
          });
          this.$emit('beforeCreate', this.formCreate.api());
        },
        created() {
          const vm = this,
            fapi = this.formCreate.api();
          const addSubForm = () => {
            if (vm.$pfc) {
              const inject = getRuleInject(vm, vm.$pfc);
              if (inject) {
                let sub;
                if (vm.isMore) {
                  sub = toArray(inject.getSubForm());
                  sub.push(fapi);
                } else {
                  sub = fapi;
                }
                inject.subForm(sub);
              }
            }
          };
          const rmSubForm = () => {
            const inject = getRuleInject(vm, vm.$pfc);
            if (inject) {
              if (vm.isMore) {
                const sub = toArray(inject.getSubForm());
                const idx = sub.indexOf(fapi);
                if (idx > -1) {
                  sub.splice(idx, 1);
                }
              } else {
                inject.subForm();
              }
            }
          };
          vm.$on('hook:beforeDestroy', () => {
            rmSubForm();
          });
          this.$watch(() => this.subForm, n => {
            n ? addSubForm() : rmSubForm();
          }, {
            immediate: true
          });
        }
      };
    }

    const normalMerge$1 = ['attrs', 'props', 'domProps', 'scopedSlots'];
    const toArrayMerge$1 = ['class', 'style', 'directives'];
    const functionalMerge$1 = ['on', 'nativeOn'];
    const mergeProps = (objects, initial = {}, opt = {}) => {
      const _normalMerge = [...normalMerge$1, ...(opt['normal'] || [])];
      const _toArrayMerge = [...toArrayMerge$1, ...(opt['array'] || [])];
      const _functionalMerge = [...functionalMerge$1, ...(opt['functional'] || [])];
      const propsMerge = opt['props'] || [];
      return objects.reduce((a, b) => {
        for (const key in b) {
          if (a[key]) {
            if (propsMerge.indexOf(key) > -1) {
              a[key] = mergeProps([b[key]], a[key]);
            } else if (_normalMerge.indexOf(key) > -1) {
              a[key] = {
                ...a[key],
                ...b[key]
              };
            } else if (_toArrayMerge.indexOf(key) > -1) {
              const arrA = a[key] instanceof Array ? a[key] : [a[key]];
              const arrB = b[key] instanceof Array ? b[key] : [b[key]];
              a[key] = [...arrA, ...arrB];
            } else if (_functionalMerge.indexOf(key) > -1) {
              for (const event in b[key]) {
                if (a[key][event]) {
                  const arrA = a[key][event] instanceof Array ? a[key][event] : [a[key][event]];
                  const arrB = b[key][event] instanceof Array ? b[key][event] : [b[key][event]];
                  a[key][event] = [...arrA, ...arrB];
                } else {
                  a[key][event] = b[key][event];
                }
              }
            } else if (key === 'hook') {
              for (let hook in b[key]) {
                if (a[key][hook]) {
                  a[key][hook] = mergeFn$1(a[key][hook], b[key][hook]);
                } else {
                  a[key][hook] = b[key][hook];
                }
              }
            } else {
              a[key] = b[key];
            }
          } else {
            if (_normalMerge.indexOf(key) > -1 || _functionalMerge.indexOf(key) > -1 || propsMerge.indexOf(key) > -1) {
              a[key] = {
                ...b[key]
              };
            } else if (_toArrayMerge.indexOf(key) > -1) {
              a[key] = b[key] instanceof Array ? [...b[key]] : typeof b[key] === 'object' ? {
                ...b[key]
              } : b[key];
            } else a[key] = b[key];
          }
        }
        return a;
      }, initial);
    };
    const mergeFn$1 = (fn1, fn2) => function () {
      fn1 && fn1.apply(this, arguments);
      fn2 && fn2.apply(this, arguments);
    };

    const keyAttrs = ['type', 'slot', 'emitPrefix', 'value', 'name', 'native', 'hidden', 'display', 'inject', 'options', 'emit', 'nativeEmit', 'link', 'prefix', 'suffix', 'update', 'sync', 'optionsTo', 'key', 'preview', 'component', 'cache'];
    const arrayAttrs = ['validate', 'children', 'control'];
    const normalAttrs = ['effect', 'deep'];
    function attrs() {
      return [...keyAttrs, ...normalMerge$1, ...toArrayMerge$1, ...functionalMerge$1, ...arrayAttrs, ...normalAttrs];
    }

    function format(type, msg, rule) {
      return `[form-create ${type}]: ${msg}` + (rule ? '\n\nrule: ' + JSON.stringify(rule.getRule ? rule.getRule() : rule) : '');
    }
    function tip(msg, rule) {
      console.warn(format('tip', msg, rule));
    }
    function err(msg, rule) {
      console.error(format('err', msg, rule));
    }
    function logError(e) {
      err(e.toString());
      console.error(e);
    }

    const PREFIX = '[[FORM-CREATE-PREFIX-';
    const SUFFIX = '-FORM-CREATE-SUFFIX]]';
    const $T = '$FN:';
    const $TX = '$FNX:';
    const FUNCTION = 'function';
    function toJson(obj, space) {
      return JSON.stringify(deepExtend([], obj, true), function (key, val) {
        if (val && val._isVue === true) return undefined;
        if (typeof val !== FUNCTION) {
          return val;
        }
        if (val.__json) {
          return val.__json;
        }
        if (val.__origin) val = val.__origin;
        if (val.__emit) return undefined;
        return PREFIX + val + SUFFIX;
      }, space);
    }
    function makeFn(fn) {
      return eval('(' + FUNCTION + '(){return ' + fn + ' })()');
    }
    function parseFn(fn, mode) {
      if (fn && is.String(fn) && fn.length > 4) {
        let v = fn.trim();
        let flag = false;
        try {
          if (v.indexOf(SUFFIX) > 0 && v.indexOf(PREFIX) === 0) {
            v = v.replace(SUFFIX, '').replace(PREFIX, '');
            flag = true;
          } else if (v.indexOf($T) === 0) {
            v = v.replace($T, '');
            flag = true;
          } else if (v.indexOf($TX) === 0) {
            v = makeFn('function($inject){' + v.replace($TX, '') + '}');
            v.__json = fn;
            v.__inject = true;
            return v;
          } else if (!mode && v.indexOf(FUNCTION) === 0 && v !== FUNCTION) {
            flag = true;
          }
          if (!flag) return fn;
          const val = makeFn(v.indexOf(FUNCTION) === -1 && v.indexOf('(') !== 0 ? FUNCTION + ' ' + v : v);
          val.__json = fn;
          return val;
        } catch (e) {
          err(`解析失败:${v}\n\nerr: ${e}`);
          return undefined;
        }
      }
      return fn;
    }
    function parseJson(json, mode) {
      return JSON.parse(json, function (k, v) {
        if (is.Undef(v) || !v.indexOf) return v;
        return parseFn(v, mode);
      });
    }

    function enumerable(value, writable) {
      return {
        value,
        enumerable: false,
        configurable: false,
        writable: !!writable
      };
    }
    function copyRule(rule) {
      return copyRules([rule])[0];
    }
    function copyRules(rules, mode) {
      return deepExtend([], [...rules], mode || false);
    }
    function mergeRule(rule, merge) {
      mergeProps(Array.isArray(merge) ? merge : [merge], rule, {
        array: arrayAttrs,
        normal: normalAttrs
      });
      return rule;
    }
    function getRule(rule) {
      const r = is.Function(rule.getRule) ? rule.getRule() : rule;
      if (!r.type) {
        r.type = 'input';
      }
      return r;
    }
    function mergeGlobal(target, merge) {
      if (!target) return merge;
      Object.keys(merge || {}).forEach(k => {
        if (merge[k]) {
          target[k] = mergeRule(target[k] || {}, merge[k]);
        }
      });
      return target;
    }
    function funcProxy(that, proxy) {
      Object.defineProperties(that, Object.keys(proxy).reduce((initial, k) => {
        initial[k] = {
          get() {
            return proxy[k]();
          }
        };
        return initial;
      }, {}));
    }
    function byCtx(rule) {
      return rule.__fc__ || (rule.__origin__ ? rule.__origin__.__fc__ : null);
    }
    function invoke(fn, def) {
      try {
        def = fn();
      } catch (e) {
        logError(e);
      }
      return def;
    }

    function baseRule() {
      return {
        props: {},
        on: {},
        options: [],
        children: [],
        effect: {},
        hidden: false,
        display: true,
        value: undefined
      };
    }
    function creatorFactory(name, init) {
      return (title, field, value, props = {}) => {
        const maker = new Creator(name, title, field, value, props);
        if (init) {
          if (is.Function(init)) init(maker);else maker.props(init);
        }
        return maker;
      };
    }
    function Creator(type, title, field, value, props) {
      this._data = extend(baseRule(), {
        type,
        title,
        field,
        value,
        props: props || {}
      });
      this.event = this.on;
    }
    extend(Creator.prototype, {
      getRule() {
        return this._data;
      },
      setProp(key, value) {
        $set(this._data, key, value);
        return this;
      },
      _clone() {
        const clone = new this.constructor();
        clone._data = copyRule(this._data);
        return clone;
      }
    });
    function appendProto(attrs) {
      attrs.forEach(name => {
        Creator.prototype[name] = function (key) {
          mergeRule(this._data, {
            [name]: arguments.length < 2 ? key : {
              [key]: arguments[1]
            }
          });
          return this;
        };
      });
    }
    appendProto(attrs());

    const commonMaker = creatorFactory('');
    function create(type, field, title) {
      let make = commonMaker('', field);
      make._data.type = type;
      make._data.title = title;
      return make;
    }
    function createTmp(template, vm, field, title) {
      let make = commonMaker('', field);
      make._data.type = 'template';
      make._data.template = template;
      make._data.title = title;
      make._data.vm = vm;
      return make;
    }
    function makerFactory() {
      return {
        create,
        createTmp,
        template: createTmp,
        factory: creatorFactory
      };
    }

    function copy(value) {
      return deepCopy(value);
    }
    function Api(h) {
      function tidyFields(fields) {
        if (is.Undef(fields)) fields = h.fields();else if (!Array.isArray(fields)) fields = [fields];
        return fields;
      }
      function props(fields, key, val) {
        tidyFields(fields).forEach(field => {
          h.getCtxs(field).forEach(ctx => {
            $set(ctx.rule, key, val);
            h.$render.clearCache(ctx);
          });
        });
      }
      function allSubForm() {
        const subs = h.subForm;
        return Object.keys(subs).reduce((initial, k) => {
          const sub = subs[k];
          if (!sub) return initial;
          if (Array.isArray(sub)) initial.push(...sub);else initial.push(sub);
          return initial;
        }, []);
      }
      const api = {
        get config() {
          return h.options;
        },
        get options() {
          return h.options;
        },
        get form() {
          return h.form;
        },
        get rule() {
          return h.rules;
        },
        get parent() {
          return h.vm.$pfc && h.vm.$pfc.$f;
        },
        get children() {
          return allSubForm();
        },
        formData(fields) {
          return tidyFields(fields).reduce((initial, id) => {
            const ctx = h.getFieldCtx(id);
            if (!ctx) return initial;
            initial[ctx.field] = copy(ctx.rule.value);
            return initial;
          }, h.options.appendValue ? copy(h.appendData) : {});
        },
        getValue(field) {
          const ctx = h.getFieldCtx(field);
          if (!ctx) return;
          return copy(ctx.rule.value);
        },
        coverValue(formData) {
          const data = {
            ...(formData || {})
          };
          h.deferSyncValue(() => {
            api.fields().forEach(key => {
              const ctxs = h.fieldCtx[key];
              if (ctxs) {
                const flag = hasProperty(data, key);
                ctxs.forEach(ctx => {
                  ctx.rule.value = flag ? data[key] : undefined;
                });
                delete data[key];
              }
            });
            extend(h.appendData, data);
          });
        },
        setValue(field) {
          let formData = field;
          if (arguments.length >= 2) formData = {
            [field]: arguments[1]
          };
          h.deferSyncValue(() => {
            Object.keys(formData).forEach(key => {
              const ctxs = h.fieldCtx[key];
              if (!ctxs) return h.appendData[key] = formData[key];
              ctxs.forEach(ctx => {
                ctx.rule.value = formData[key];
              });
            });
          });
        },
        removeField(field) {
          const ctx = h.getCtx(field);
          h.deferSyncValue(() => {
            h.getCtxs(field).forEach(ctx => {
              ctx.rm();
            });
          }, true);
          return ctx ? ctx.origin : undefined;
        },
        removeRule(rule) {
          const ctx = rule && byCtx(rule);
          if (!ctx) return;
          ctx.rm();
          return ctx.origin;
        },
        destroy: () => {
          h.vm.$el.parentNode && h.vm.$el.parentNode.removeChild(h.vm.$el);
          h.vm.$destroy();
        },
        fields: () => h.fields(),
        append: (rule, after, child) => {
          let index = h.sort.length - 1,
            rules;
          const ctx = h.getCtx(after);
          if (ctx) {
            if (child) {
              rules = ctx.rule.children;
              index = ctx.rule.children.length - 1;
            } else {
              index = ctx.root.indexOf(ctx.origin);
              rules = ctx.root;
            }
          } else rules = h.rules;
          rules.splice(index + 1, 0, rule);
        },
        prepend: (rule, after, child) => {
          let index = 0,
            rules;
          const ctx = h.getCtx(after);
          if (ctx) {
            if (child) {
              rules = ctx.rule.children;
            } else {
              index = ctx.root.indexOf(ctx.origin);
              rules = ctx.root;
            }
          } else rules = h.rules;
          rules.splice(index, 0, rule);
        },
        hidden(state, fields) {
          props(fields, 'hidden', !!state);
          h.refresh();
        },
        hiddenStatus(id) {
          const ctx = h.getCtx(id);
          if (!ctx) return;
          return !!ctx.rule.hidden;
        },
        display(state, fields) {
          props(fields, 'display', !!state);
          h.refresh();
        },
        displayStatus(id) {
          const ctx = h.getCtx(id);
          if (!ctx) return;
          return !!ctx.rule.display;
        },
        disabled(disabled, fields) {
          tidyFields(fields).forEach(field => {
            h.getCtxs(field).forEach(ctx => {
              ctx.rule.props && $set(ctx.rule.props, 'disabled', !!disabled);
            });
          });
          h.refresh();
        },
        all(origin) {
          return Object.keys(h.ctxs).map(k => {
            const ctx = h.ctxs[k];
            return origin ? ctx.origin : ctx.rule;
          });
        },
        model(origin) {
          return h.fields().reduce((initial, key) => {
            const ctx = h.fieldCtx[key][0];
            initial[key] = origin ? ctx.origin : ctx.rule;
            return initial;
          }, {});
        },
        component(origin) {
          return Object.keys(h.nameCtx).reduce((initial, key) => {
            const ctx = h.nameCtx[key].map(ctx => origin ? ctx.origin : ctx.rule);
            initial[key] = ctx.length === 1 ? ctx[0] : ctx;
            return initial;
          }, {});
        },
        bind() {
          return api.form;
        },
        reload: rules => {
          h.reloadRule(rules);
        },
        updateOptions(options) {
          h.fc.updateOptions(options);
          api.refresh();
        },
        onSubmit(fn) {
          api.updateOptions({
            onSubmit: fn
          });
        },
        sync: field => {
          if (Array.isArray(field)) {
            field.forEach(v => api.sync(v));
            return;
          }
          let ctxs = is.Object(field) ? byCtx(field) : h.getCtxs(field);
          if (!ctxs) {
            return;
          }
          ctxs = Array.isArray(ctxs) ? ctxs : [ctxs];
          ctxs.forEach(ctx => {
            if (!ctx.deleted) {
              const subForm = h.subForm[ctx.id];
              if (subForm) {
                if (Array.isArray(subForm)) {
                  subForm.forEach(form => {
                    form.refresh();
                  });
                } else if (subForm) {
                  subForm.refresh();
                }
              }
              h.$render.clearCache(ctx);
            }
          });
          h.refresh();
        },
        refresh: () => {
          allSubForm().forEach(sub => {
            sub.refresh();
          });
          h.$render.clearCacheAll();
          h.refresh();
        },
        refreshOptions() {
          h.$manager.updateOptions(h.options);
          api.refresh();
        },
        hideForm: hide => {
          $set(h.vm, 'isShow', !hide);
        },
        changeStatus: () => {
          return h.changeStatus;
        },
        clearChangeStatus: () => {
          h.changeStatus = false;
        },
        updateRule(id, rule) {
          h.getCtxs(id).forEach(ctx => {
            extend(ctx.rule, rule);
          });
        },
        updateRules(rules) {
          Object.keys(rules).forEach(id => {
            api.updateRule(id, rules[id]);
          });
        },
        mergeRule: (id, rule) => {
          h.getCtxs(id).forEach(ctx => {
            mergeRule(ctx.rule, rule);
          });
        },
        mergeRules(rules) {
          Object.keys(rules).forEach(id => {
            api.mergeRule(id, rules[id]);
          });
        },
        getRule: (id, origin) => {
          const ctx = h.getCtx(id);
          if (ctx) {
            return origin ? ctx.origin : ctx.rule;
          }
        },
        setEffect(id, attr, value) {
          const ctx = h.getCtx(id);
          if (ctx && attr) {
            if (attr[0] === '$') {
              attr = attr.substr(1);
            }
            if (hasProperty(ctx.rule, '$' + attr)) {
              $set(ctx.rule, '$' + attr, value);
            }
            if (!hasProperty(ctx.rule, 'effect')) {
              $set(ctx.rule, 'effect', {});
            }
            $set(ctx.rule.effect, attr, value);
          }
        },
        clearEffectData(id, attr) {
          const ctx = h.getCtx(id);
          if (ctx) {
            if (attr && attr[0] === '$') {
              attr = attr.substr(1);
            }
            ctx.clearEffectData(attr);
            api.sync(id);
          }
        },
        updateValidate(id, validate, merge) {
          if (merge) {
            api.mergeRule(id, {
              validate
            });
          } else {
            props(id, 'validate', validate);
          }
        },
        updateValidates(validates, merge) {
          Object.keys(validates).forEach(id => {
            api.updateValidate(id, validates[id], merge);
          });
        },
        refreshValidate() {
          h.vm.validate = {};
          api.refresh();
        },
        resetFields(fields) {
          tidyFields(fields).forEach(field => {
            h.getCtxs(field).forEach(ctx => {
              h.$render.clearCache(ctx);
              ctx.rule.value = copy(ctx.defaultValue);
            });
          });
        },
        method(id, name) {
          const el = api.el(id);
          if (!el || !el[name]) throw new Error(format('err', `${name}方法不存在`));
          return (...args) => {
            return el[name](...args);
          };
        },
        exec(id, name, ...args) {
          return invoke(() => api.method(id, name)(...args));
        },
        toJson(space) {
          return toJson(api.rule, space);
        },
        trigger(id, event, ...args) {
          const el = api.el(id);
          el && el.$emit(event, ...args);
        },
        el(id) {
          const ctx = h.getCtx(id);
          if (ctx) return ctx.el || h.vm.$refs[ctx.ref];
        },
        closeModal: id => {
          const el = api.el(id);
          el && el.$emit && el.$emit('close-modal');
        },
        getSubForm(field) {
          const ctx = h.getCtx(field);
          return ctx ? h.subForm[ctx.id] : undefined;
        },
        nextTick(fn) {
          h.bus.$once('next-tick', fn);
          h.refresh();
        },
        nextRefresh(fn) {
          h.nextRefresh();
          fn && invoke(fn);
        },
        emit(name, ...args) {
          h.vm.$emit(name, ...args);
        },
        deferSyncValue(fn, sync) {
          h.deferSyncValue(fn, sync);
        },
        helper: {
          tidyFields,
          props
        }
      };
      ['on', 'once', 'off', 'set'].forEach(n => {
        api[n] = function (...args) {
          h.vm[`$${n}`](...args);
        };
      });
      api.changeValue = api.changeField = api.setValue;
      return api;
    }

    function useCache(Render) {
      extend(Render.prototype, {
        initCache() {
          this.clearCacheAll();
        },
        clearCache(ctx) {
          if (ctx.rule.cache) {
            return;
          }
          if (!this.cache[ctx.id]) {
            ctx.parent && this.clearCache(ctx.parent);
            return;
          }
          if (this.cache[ctx.id].use === true || this.cache[ctx.id].parent) {
            this.$handle.refresh();
          }
          const parent = this.cache[ctx.id].parent;
          this.cache[ctx.id] = null;
          parent && this.clearCache(parent);
        },
        clearCacheAll() {
          this.cache = {};
        },
        setCache(ctx, vnode, parent) {
          this.cache[ctx.id] = {
            vnode,
            use: false,
            parent,
            slot: ctx.rule.slot
          };
        },
        getCache(ctx) {
          const cache = this.cache[ctx.id];
          if (cache) {
            cache.use = true;
            return cache.vnode;
          }
          return undefined;
        }
      });
    }

    function toCase(str) {
      const to = str.replace(/(-[a-z])/g, function (v) {
        return v.replace('-', '').toLocaleUpperCase();
      });
      return lower(to);
    }
    function lower(str) {
      return str.replace(str[0], str[0].toLowerCase());
    }

    function toString(val) {
      return val == null ? '' : typeof val === 'object' ? JSON.stringify(val, null, 2) : String(val);
    }

    function toLine(name) {
      let line = name.replace(/([A-Z])/g, '-$1').toLocaleLowerCase();
      if (line.indexOf('-') === 0) line = line.substr(1);
      return line;
    }

    let id = 0;
    function uniqueId() {
      return 'F' + Math.random().toString(36).substr(3, 3) + Number(`${Date.now()}${++id}`).toString(36);
    }

    function deepSet(data, idx, val) {
      let _data = data,
        to;
      (idx || '').split('.').forEach(v => {
        if (to) {
          if (!_data[to] || typeof _data[to] != 'object') {
            _data[to] = {};
          }
          _data = _data[to];
        }
        to = v;
      });
      _data[to] = val;
      return _data;
    }

    function useRender(Render) {
      extend(Render.prototype, {
        initRender() {
          this.tempList = {};
          this.clearOrgChildren();
        },
        initOrgChildren() {
          const ctxs = this.$handle.ctxs;
          this.orgChildren = Object.keys(ctxs).reduce((initial, id) => {
            if (ctxs[id].parser.loadChildren !== false) {
              const children = ctxs[id].rule.children;
              initial[id] = is.trueArray(children) ? [...children] : [];
            }
            return initial;
          }, {});
        },
        clearOrgChildren() {
          this.orgChildren = {};
        },
        getTypeSlot(type) {
          const name = 'type-' + toLine(type);
          const _fn = vm => {
            if (vm) {
              const slot = vm.$scopedSlots[name] || vm.$scopedSlots['type-' + type];
              if (slot) {
                return slot;
              }
              return _fn(vm.$pfc);
            }
          };
          return _fn(this.vm);
        },
        render() {
          if (!this.vm.isShow) {
            return;
          }
          this.$h = this.vm.$createElement;
          this.$manager.beforeRender();
          let vn;
          const make = () => this.renderList();
          make.renderSlot = slot => this.renderList(slot);
          make.renderName = name => this.renderId(name);
          make.renderField = field => this.renderId(field, 'field');
          if (this.vm.$scopedSlots.container) {
            vn = [this.vm.$scopedSlots.container(make)];
          } else {
            vn = make();
          }
          return this.$manager.render(vn);
        },
        renderList(slot) {
          return this.sort.map(id => {
            return slot ? this.renderSlot(this.$handle.ctxs[id], slot) : this.renderCtx(this.$handle.ctxs[id]);
          }).filter(val => val !== undefined);
        },
        makeVm(rule) {
          const vm = rule.vm;
          if (!vm) return new _vue();else if (is.Function(vm)) return invoke(() => rule.vm(this.$handle.getInjectData(rule)));else if (!vm._isVue) return new _vue(vm);
          return vm;
        },
        mergeGlobal(ctx) {
          const g = this.$handle.options.global;
          if (!g) return;
          if (!ctx.cacheConfig) ctx.cacheConfig = g[ctx.originType] || g[ctx.type] || g[ctx.trueType] || {};
          ctx.prop = mergeRule({}, [g['*'], ctx.cacheConfig, ctx.prop]);
        },
        setOptions(ctx) {
          if (ctx.prop.optionsTo && ctx.prop.options) {
            deepSet(ctx.prop, ctx.prop.optionsTo, ctx.prop.options);
          }
        },
        deepSet(ctx) {
          const deep = ctx.rule.deep;
          deep && Object.keys(deep).sort((a, b) => a.length < b.length ? -1 : 1).forEach(str => {
            deepSet(ctx.prop, str, deep[str]);
          });
        },
        setTempProps(vm, ctx) {
          if (!vm.$props) return;
          const {
            prop
          } = ctx;
          const keys = Object.keys(vm.$props);
          const inject = this.injectProp(ctx);
          const injectKeys = Object.keys(inject);
          keys.forEach(key => {
            if (hasProperty(prop.props, key)) vm.$props[key] = prop.props[key];else if (injectKeys.indexOf(key) > -1) vm.$props[key] = inject[key];
          });
          const key = vm.$options.model && vm.$options.model.prop || 'value';
          if (keys.indexOf(key) > -1) {
            vm.$props[key] = prop.value;
          }
        },
        renderTemp(ctx) {
          if (!_vue.compile) {
            tip('当前使用的Vue构建版本不支持compile,无法使用template功能');
            return [];
          }
          const rule = ctx.prop;
          const {
            id,
            key
          } = ctx;
          if (!this.tempList[id]) {
            if (!ctx.el) {
              ctx.el = this.makeVm(rule);
              this.vm.$nextTick(() => ctx.parser.mounted(ctx));
            }
            let vm = ctx.el;
            if (ctx.input) vm.$on(vm.$options.model && vm.$options.model.event || 'input', value => {
              this.onInput(ctx, value);
            });
            this.tempList[id] = {
              vm,
              template: _vue.compile(rule.template)
            };
          }
          const {
            vm,
            template
          } = this.tempList[id];
          this.setTempProps(vm, ctx);
          const vn = template.render.call(vm);
          if (is.Undef(vn.data)) vn.data = {};
          vn.key = key;
          vn.data.ref = ctx.ref;
          vn.data.key = key;
          return vn;
        },
        parseSide(side) {
          return is.Object(side) ? mergeRule({}, side) : side;
        },
        renderSides(vn, ctx, temp) {
          const prop = ctx[temp ? 'rule' : 'prop'];
          return [this.renderRule(this.parseSide(prop.prefix)), vn, this.renderRule(this.parseSide(prop.suffix))];
        },
        renderSlot(ctx, slot) {
          return ctx.rule.slot === slot ? this.renderCtx(ctx) : undefined;
        },
        renderId(name, type) {
          const ctxs = this.$handle[type === 'field' ? 'fieldCtx' : 'nameCtx'][name];
          return ctxs ? ctxs.map(ctx => this.renderCtx(ctx, ctx.parent)) : undefined;
        },
        renderCtx(ctx, parent) {
          if (ctx.type === 'hidden') return;
          const rule = ctx.rule;
          if (!this.cache[ctx.id] || this.cache[ctx.id].slot !== rule.slot) {
            let vn;
            let cacheFlag = rule.cache !== false;
            const _type = ctx.trueType;
            const none = !(is.Undef(rule.display) || !!rule.display);
            if (_type === 'template' && !rule.template) {
              vn = this.renderSides(this.renderChildren(ctx), ctx, true);
              if (none) {
                this.display(vn);
              }
              vn = this.item(ctx, vn);
            } else if (_type === 'fcFragment') {
              vn = this.renderChildren(ctx);
            } else {
              ctx.initProp();
              this.mergeGlobal(ctx);
              this.$manager.tidyRule(ctx);
              this.deepSet(ctx);
              this.setOptions(ctx);
              this.ctxProp(ctx);
              let prop = ctx.prop;
              prop.preview = !!(hasProperty(prop, 'preview') ? prop.preview : this.options.preview || false);
              prop.props.formCreateInject = this.injectProp(ctx);
              const preview = prop.preview;
              if (prop.hidden) {
                this.setCache(ctx, undefined, parent);
                return;
              }
              if (_type === 'template' && prop.template) {
                vn = this.renderTemp(ctx);
                cacheFlag = false;
              } else {
                let children = [];
                if (ctx.parser.renderChildren) {
                  children = ctx.parser.renderChildren(ctx);
                } else if (ctx.parser.loadChildren !== false) {
                  children = this.renderChildren(ctx);
                }
                const slot = this.getTypeSlot(ctx.type);
                if (slot) {
                  vn = slot({
                    rule,
                    prop,
                    preview,
                    children,
                    api: this.$handle.api,
                    model: prop.model || {}
                  });
                } else {
                  vn = preview ? ctx.parser.preview(children, ctx) : ctx.parser.render(children, ctx);
                }
              }
              vn = this.renderSides(vn, ctx);
              if (!(!ctx.input && is.Undef(prop.native)) && prop.native !== true) {
                vn = this.$manager.makeWrap(ctx, vn);
              }
              if (none) {
                vn = this.display(vn);
              }
              vn = this.item(ctx, vn);
            }
            if (cacheFlag) {
              this.setCache(ctx, vn, parent);
            }
            return vn;
          }
          return this.getCache(ctx);
        },
        display(vn) {
          if (Array.isArray(vn)) {
            const data = [];
            vn.forEach(v => {
              if (Array.isArray(v)) return this.display(v);
              if (this.none(v)) data.push(v);
            });
            return data;
          } else {
            return this.none(vn);
          }
        },
        none(vn) {
          if (vn && vn.data) {
            if (Array.isArray(vn.data.style)) {
              vn.data.style.push({
                display: 'none'
              });
            } else if (is.String(vn.data.style)) {
              vn.data.style += ';display:none;';
            } else {
              vn.data.style = [vn.data.style, {
                display: 'none'
              }];
            }
            return vn;
          }
        },
        item(ctx, vn) {
          return this.$h('fcFragment', {
            slot: ctx.rule.slot,
            key: ctx.key
          }, [vn]);
        },
        injectProp(ctx) {
          if (!this.vm.ctxInject[ctx.id]) {
            $set(this.vm.ctxInject, ctx.id, {
              api: this.$handle.api,
              form: this.fc.create,
              subForm: subForm => {
                this.$handle.addSubForm(ctx, subForm);
              },
              getSubForm: () => {
                return this.$handle.subForm[ctx.id];
              },
              options: [],
              children: [],
              prop: {},
              preview: false,
              field: ctx.field,
              rule: ctx.rule,
              input: ctx.input
            });
          }
          const inject = this.vm.ctxInject[ctx.id];
          extend(inject, {
            preview: ctx.prop.preview,
            options: ctx.prop.options,
            children: ctx.rule.children,
            prop: function () {
              const temp = {
                ...ctx.prop
              };
              temp.on = temp.on ? {
                ...temp.on
              } : {};
              delete temp.model;
              return temp;
            }()
          });
          return inject;
        },
        ctxProp(ctx, custom) {
          const {
            ref,
            key,
            rule
          } = ctx;
          this.$manager.mergeProp(ctx, custom);
          ctx.parser.mergeProp(ctx, custom);
          const props = [{
            ref: ref,
            key: rule.key || `${key}fc`,
            slot: undefined,
            on: {
              'hook:mounted': () => {
                this.onMounted(ctx);
              },
              'fc.sub-form': subForm => {
                this.$handle.addSubForm(ctx, subForm);
              }
            }
          }];
          if (!custom && ctx.input) {
            ctx.prop.model = {
              value: this.$handle.getFormData(ctx),
              callback: value => {
                this.onInput(ctx, value);
              },
              expression: `formData.${ctx.id}`
            };
          }
          mergeProps(props, ctx.prop);
          return ctx.prop;
        },
        onMounted(ctx) {
          ctx.el = this.vm.$refs[ctx.ref];
          if (ctx.el) {
            (ctx.el.$el || ctx.el).__rule__ = ctx.rule;
          }
          ctx.parser.mounted(ctx);
          this.$handle.effect(ctx, 'mounted');
        },
        onInput(ctx, value) {
          this.$handle.onInput(ctx, value);
        },
        renderChildren(ctx) {
          const {
              children
            } = ctx.rule,
            orgChildren = this.orgChildren[ctx.id];
          const isRm = child => {
            return !is.String(child) && child.__fc__ && !this.$handle.ctxs[child.__fc__.id];
          };
          if (!is.trueArray(children) && orgChildren) {
            this.$handle.deferSyncValue(() => {
              orgChildren.forEach(child => {
                if (!child) return;
                if (isRm(child)) {
                  this.$handle.rmCtx(child.__fc__);
                }
              });
            });
            this.orgChildren[ctx.id] = [];
            return [];
          }
          orgChildren && this.$handle.deferSyncValue(() => {
            orgChildren.forEach(child => {
              if (!child) return;
              if (children.indexOf(child) === -1 && isRm(child)) {
                this.$handle.rmCtx(child.__fc__);
              }
            });
          });
          return children.map(child => {
            if (!child) return;
            if (is.String(child)) return child;
            if (child.__fc__) {
              return this.renderCtx(child.__fc__, ctx);
            }
            if (child.type) {
              this.vm.$nextTick(() => {
                this.$handle.loadChildren(children, ctx);
                this.$handle.refresh();
              });
            }
          });
        },
        defaultRender(ctx, children) {
          const prop = ctx.prop;
          if (prop.component) return this.vNode.makeComponent(prop.component, prop, children);
          if (this.vNode[ctx.type]) return this.vNode[ctx.type](prop, children);
          if (this.vNode[ctx.originType]) return this.vNode[ctx.originType](prop, children);
          return this.vNode.make(lower(ctx.originType), prop, children);
        },
        renderRule(rule, children, origin) {
          if (!rule) return undefined;
          if (is.String(rule)) return rule;
          let type;
          if (origin) {
            type = rule.type;
          } else {
            type = rule.is;
            if (rule.type) {
              type = toCase(rule.type);
              const alias = this.vNode.aliasMap[type];
              if (alias) type = toCase(alias);
            }
          }
          if (!type) return undefined;
          let data = [[children]];
          if (is.trueArray(rule.children)) {
            data.push(rule.children.map(v => this.renderRule(v)));
          }
          return this.$h(type, {
            ...rule
          }, data);
        }
      });
    }

    function Render(handle) {
      extend(this, {
        $handle: handle,
        fc: handle.fc,
        vm: handle.vm,
        $manager: handle.$manager,
        vNode: new handle.fc.CreateNode(handle.vm)
      });
      funcProxy(this, {
        options() {
          return handle.options;
        },
        sort() {
          return handle.sort;
        }
      });
      this.initCache();
      this.initRender();
    }
    useCache(Render);
    useRender(Render);

    function useInject(Handler) {
      extend(Handler.prototype, {
        parseInjectEvent(rule, on) {
          const inject = rule.inject || this.options.injectEvent;
          return this.parseEventLst(rule, on, inject);
        },
        parseEventLst(rule, data, inject, deep) {
          Object.keys(data).forEach(k => {
            const fn = this.parseEvent(rule, data[k], inject, deep);
            if (fn) {
              data[k] = fn;
            }
          });
          return data;
        },
        parseEvent(rule, fn, inject, deep) {
          if (is.Function(fn) && (inject !== false && !is.Undef(inject) || fn.__inject)) {
            return this.inject(rule, fn, inject);
          } else if (!deep && Array.isArray(fn) && fn[0] && (is.String(fn[0]) || is.Function(fn[0]))) {
            return this.parseEventLst(rule, fn, inject, true);
          } else if (is.String(fn)) {
            const val = parseFn(fn);
            if (val && fn !== val) {
              return val.__inject ? this.parseEvent(rule, val, inject, true) : val;
            }
          }
        },
        parseEmit(ctx, on) {
          let event = {},
            rule = ctx.rule,
            {
              emitPrefix,
              field,
              name,
              inject
            } = rule;
          let emit = rule[on ? 'emit' : 'nativeEmit'] || [];
          if (is.trueArray(emit)) {
            let emitKey = emitPrefix || field || name;
            if (emitKey) {
              if (!on) emitKey = `native-${emitKey}`;
              emit.forEach(eventName => {
                if (!eventName) return;
                let eventInject;
                if (is.Object(eventName)) {
                  eventInject = eventName.inject;
                  eventName = eventName.name;
                }
                const fieldKey = toLine(`${emitKey}-${eventName}`);
                const fn = (...arg) => {
                  this.vm.$emit(fieldKey, ...arg);
                  this.vm.$emit('emit-event', fieldKey, ...arg);
                };
                fn.__emit = true;
                if (!eventInject && inject === false) {
                  event[eventName] = fn;
                } else {
                  let _inject = eventInject || inject || this.options.injectEvent;
                  event[eventName] = is.Undef(_inject) ? fn : this.inject(rule, fn, _inject);
                }
              });
            }
          }
          ctx.computed[on ? 'on' : 'nativeOn'] = event;
          return event;
        },
        getInjectData(self, inject) {
          const {
            option,
            rule
          } = this.vm.$options.propsData;
          return {
            api: this.api,
            $f: this.api,
            rule,
            self: self.__origin__,
            option,
            inject
          };
        },
        inject(self, _fn, inject) {
          if (_fn.__origin) {
            if (this.watching && !this.loading) return _fn;
            _fn = _fn.__origin;
          }
          const h = this;
          const fn = function (...args) {
            const data = h.getInjectData(self, inject);
            data.args = [...args];
            args.unshift(data);
            return _fn.apply(this, args);
          };
          fn.__origin = _fn;
          fn.__json = _fn.__json;
          return fn;
        }
      });
    }

    const EVENT = ['hook:updated', 'hook:mounted'];
    function usePage(Handler) {
      extend(Handler.prototype, {
        usePage() {
          const page = this.options.page;
          if (!page) return;
          let first = 25;
          let limit = getLimit(this.rules);
          if (is.Object(page)) {
            if (page.first) first = parseInt(page.first, 10) || first;
            if (page.limit) limit = parseInt(page.limit, 10) || limit;
          }
          extend(this, {
            first,
            limit,
            pageEnd: this.rules.length <= first
          });
          this.bus.$on('page-end', () => this.vm.$emit('page-end', this.api));
          this.pageLoad();
        },
        pageLoad() {
          const pageFn = () => {
            if (this.pageEnd) {
              this.vm.$off(EVENT, pageFn);
              this.bus.$emit('page-end');
            } else {
              this.first += this.limit;
              this.pageEnd = this.rules.length <= this.first;
              this.loadRule();
              this.refresh();
            }
          };
          this.vm.$on(EVENT, pageFn);
        }
      });
    }
    function getLimit(rules) {
      return rules.length < 31 ? 31 : Math.ceil(rules.length / 3);
    }

    function useRender$1(Handler) {
      extend(Handler.prototype, {
        clearNextTick() {
          this.nextTick && clearTimeout(this.nextTick);
          this.nextTick = null;
        },
        bindNextTick(fn) {
          this.clearNextTick();
          this.nextTick = setTimeout(() => {
            fn();
            this.nextTick = null;
          }, 10);
        },
        render() {
          ++this.loadedId;
          if (this.vm.unique > 0) return this.$render.render();else {
            this.vm.unique = 1;
            return [];
          }
        }
      });
    }

    function bind(ctx) {
      Object.defineProperties(ctx.origin, {
        __fc__: enumerable(ctx, true)
      });
    }
    function RuleContext(handle, rule, defaultValue) {
      const id = uniqueId();
      extend(this, {
        id,
        ref: id,
        wrapRef: id + 'fi',
        rule,
        origin: rule.__origin__ || rule,
        name: rule.name,
        watch: [],
        linkOn: [],
        root: [],
        ctrlRule: [],
        parent: null,
        cacheConfig: null,
        prop: {
          ...rule
        },
        computed: {},
        payload: {},
        input: !!rule.field,
        el: undefined,
        defaultValue: rule.field ? deepCopy(defaultValue) : undefined,
        field: rule.field || undefined
      });
      this.updateType();
      this.updateKey();
      bind(this);
      this.update(handle, true);
    }
    extend(RuleContext.prototype, {
      effectData(name) {
        if (!this.payload[name]) {
          this.payload[name] = {};
        }
        return this.payload[name];
      },
      clearEffectData(name) {
        if (name === undefined) {
          this.payload = {};
        } else {
          delete this.payload[name];
        }
      },
      updateKey(flag) {
        this.key = uniqueId();
        flag && this.parent && this.parent.updateKey(flag);
      },
      updateType() {
        this.originType = this.rule.type;
        this.type = toCase(this.rule.type);
      },
      setParser(parser) {
        this.parser = parser;
        parser.init(this);
      },
      initProp() {
        const rule = {
          ...this.rule
        };
        delete rule.children;
        this.prop = mergeRule({}, [rule, ...Object.keys(this.payload).map(k => this.payload[k]), this.computed]);
      },
      check(handle) {
        return this.vm === handle.vm;
      },
      unwatch() {
        this.watch.forEach(un => un());
        this.watch = [];
      },
      unlink() {
        this.linkOn.forEach(un => un());
        this.linkOn = [];
      },
      link() {
        this.unlink();
        this.$handle.appendLink(this);
      },
      watchTo() {
        this.$handle.watchCtx(this);
      },
      delete() {
        const undef = void 0;
        this.unwatch();
        this.unlink();
        this.rmCtrl();
        extend(this, {
          deleted: true,
          prop: {
            ...this.rule
          },
          computed: {},
          el: undef,
          $handle: undef,
          $render: undef,
          $api: undef,
          vm: undef,
          vNode: undef,
          parent: null,
          cacheConfig: null
        });
      },
      rmCtrl() {
        this.ctrlRule.forEach(ctrl => ctrl.__fc__ && ctrl.__fc__.rm());
        this.ctrlRule = [];
      },
      rm() {
        const _rm = () => {
          let index = this.root.indexOf(this.origin);
          if (index > -1) {
            this.root.splice(index, 1);
            this.$handle && this.$handle.refresh();
          }
        };
        if (this.deleted) {
          _rm();
          return;
        }
        this.$handle.noWatch(() => {
          this.$handle.deferSyncValue(() => {
            this.rmCtrl();
            _rm();
            this.$handle.rmCtx(this);
            extend(this, {
              root: []
            });
          }, this.input);
        });
      },
      update(handle, init) {
        extend(this, {
          deleted: false,
          $handle: handle,
          $render: handle.$render,
          $api: handle.api,
          vm: handle.vm,
          trueType: handle.getType(this.originType),
          vNode: handle.$render.vNode,
          updated: false
        });
        !init && this.unwatch();
        this.watchTo();
        this.link();
      }
    });

    const condition = {
      '==': b => a => a === b,
      '!=': b => a => a !== b,
      '<>': b => a => a !== b,
      '>': b => a => a > b,
      '>=': b => a => a >= b,
      '<': b => a => a < b,
      '<=': b => a => a <= b,
      'in': b => a => b && b.indexOf && b.indexOf(a) > -1,
      'on': b => a => a && a.indexOf && a.indexOf(b) > -1,
      'notIn': b => a => !condition.in(b)(a),
      'notOn': b => a => !condition.on(b)(a),
      'between': b => a => a > b[0] && a < b[1],
      'notBetween': b => a => a < b[0] || a > b[1]
    };
    function useLoader(Handler) {
      extend(Handler.prototype, {
        nextRefresh(fn) {
          const id = this.loadedId;
          this.vm.$nextTick(() => {
            id === this.loadedId && (fn ? fn() : this.refresh());
          });
        },
        parseRule(_rule) {
          const rule = getRule(_rule);
          Object.defineProperties(rule, {
            __origin__: enumerable(_rule, true)
          });
          fullRule(rule);
          this.appendValue(rule);
          rule.options = Array.isArray(rule.options) ? rule.options : [];
          [rule, rule['prefix'], rule['suffix']].forEach(item => {
            if (!item) {
              return;
            }
            this.loadFn(item, rule);
          });
          this.loadCtrl(rule);
          if (rule.update) {
            rule.update = parseFn(rule.update);
          }
          return rule;
        },
        loadFn(item, rule) {
          ['on', 'props', 'nativeOn', 'deep'].forEach(k => {
            item[k] && this.parseInjectEvent(rule, item[k]);
          });
        },
        loadCtrl(rule) {
          rule.control && rule.control.forEach(ctrl => {
            if (ctrl.handle) {
              ctrl.handle = parseFn(ctrl.handle);
            }
          });
        },
        syncProp(ctx) {
          const rule = ctx.rule;
          is.trueArray(rule.sync) && mergeProps([{
            on: rule.sync.reduce((pre, prop) => {
              pre[`update:${prop}`] = val => {
                rule.props[prop] = val;
                this.vm.$emit('sync', prop, val, rule, this.fapi);
              };
              return pre;
            }, {})
          }], ctx.computed);
        },
        loadRule() {
          this.cycleLoad = false;
          this.loading = true;
          if (this.pageEnd) {
            this.bus.$emit('load-start');
          }
          this.deferSyncValue(() => {
            this._loadRule(this.rules);
            this.loading = false;
            if (this.cycleLoad && this.pageEnd) {
              return this.loadRule();
            }
            if (this.pageEnd) {
              this.bus.$emit('load-end');
            }
            this.vm._renderRule();
            this.$render.initOrgChildren();
            this.syncForm();
          });
        },
        loadChildren(children, parent) {
          this.cycleLoad = false;
          this.loading = true;
          this.bus.$emit('load-start');
          this._loadRule(children, parent);
          this.loading = false;
          if (this.cycleLoad) {
            return this.loadRule();
          } else {
            this.bus.$emit('load-end');
            this.syncForm();
          }
          this.$render.clearCache(parent);
        },
        _loadRule(rules, parent) {
          const preIndex = i => {
            let pre = rules[i - 1];
            if (!pre || !pre.__fc__) {
              return i > 0 ? preIndex(i - 1) : -1;
            }
            let index = this.sort.indexOf(pre.__fc__.id);
            return index > -1 ? index : preIndex(i - 1);
          };
          const loadChildren = (children, parent) => {
            if (is.trueArray(children)) {
              this._loadRule(children, parent);
            }
          };
          rules.map((_rule, index) => {
            if (parent && !is.Object(_rule)) return;
            if (!this.pageEnd && !parent && index >= this.first) return;
            if (_rule.__fc__ && _rule.__fc__.root === rules && this.ctxs[_rule.__fc__.id]) {
              loadChildren(_rule.__fc__.rule.children, _rule.__fc__);
              return _rule.__fc__;
            }
            let rule = getRule(_rule);
            const isRepeat = () => {
              return !!(rule.field && this.fieldCtx[rule.field] && this.fieldCtx[rule.field][0] !== _rule.__fc__);
            };
            this.ruleEffect(rule, 'init', {
              repeat: isRepeat()
            });
            if (isRepeat()) {
              this.vm.$emit('repeat-field', _rule, this.api);
            }
            let ctx;
            let isCopy = false;
            let isInit = !!_rule.__fc__;
            let defaultValue = rule.value;
            if (isInit) {
              ctx = _rule.__fc__;
              defaultValue = ctx.defaultValue;
              const check = !ctx.check(this);
              if (ctx.deleted) {
                if (check) {
                  if (isCtrl(ctx)) {
                    return;
                  }
                  ctx.update(this);
                }
              } else {
                if (check) {
                  if (isCtrl(ctx)) {
                    return;
                  }
                  rules[index] = _rule = _rule._clone ? _rule._clone() : copyRule(_rule);
                  ctx = null;
                  isCopy = true;
                }
              }
            }
            if (!ctx) {
              const rule = this.parseRule(_rule);
              ctx = new RuleContext(this, rule, isInit ? defaultValue : rule.value);
              this.bindParser(ctx);
            } else {
              if (ctx.originType !== ctx.rule.type) {
                ctx.updateType();
                this.bindParser(ctx);
              }
              this.appendValue(ctx.rule);
            }
            [false, true].forEach(b => this.parseEmit(ctx, b));
            this.syncProp(ctx);
            ctx.parent = parent || null;
            ctx.root = rules;
            this.setCtx(ctx);
            !isCopy && !isInit && this.effect(ctx, 'load');
            ctx.parser.loadChildren === false || loadChildren(ctx.rule.children, ctx);
            if (!parent) {
              const _preIndex = preIndex(index);
              if (_preIndex > -1 || !index) {
                this.sort.splice(_preIndex + 1, 0, ctx.id);
              } else {
                this.sort.push(ctx.id);
              }
            }
            const r = ctx.rule;
            if (!ctx.updated) {
              ctx.updated = true;
              if (is.Function(r.update)) {
                this.bus.$once('load-end', () => {
                  this.refreshUpdate(ctx, r.value);
                });
              }
              this.effect(ctx, 'loaded');
            }
            if (ctx.input) Object.defineProperty(r, 'value', this.valueHandle(ctx));
            if (this.refreshControl(ctx)) this.cycleLoad = true;
            return ctx;
          });
        },
        refreshControl(ctx) {
          return ctx.input && ctx.rule.control && this.useCtrl(ctx);
        },
        useCtrl(ctx) {
          const controls = getCtrl(ctx),
            validate = [],
            api = this.api;
          if (!controls.length) return false;
          for (let i = 0; i < controls.length; i++) {
            const control = controls[i],
              handleFn = control.handle || (condition[control.condition || '=='] || condition['=='])(control.value);
            if (!is.trueArray(control.rule)) continue;
            const data = {
              ...control,
              valid: invoke(() => handleFn(ctx.rule.value, api)),
              ctrl: findCtrl(ctx, control.rule),
              isHidden: is.String(control.rule[0])
            };
            if (data.valid && data.ctrl || !data.valid && !data.ctrl && !data.isHidden) continue;
            validate.push(data);
          }
          if (!validate.length) return false;
          const hideLst = [];
          let flag = false;
          this.deferSyncValue(() => {
            validate.reverse().forEach(({
              isHidden,
              valid,
              rule,
              prepend,
              append,
              child,
              ctrl,
              method
            }) => {
              if (isHidden) {
                valid ? ctx.ctrlRule.push({
                  __ctrl: true,
                  children: rule,
                  valid
                }) : ctx.ctrlRule.splice(ctx.ctrlRule.indexOf(ctrl), 1);
                hideLst[valid ? 'push' : 'unshift'](() => {
                  if (method === 'disabled') {
                    this.api.disabled(!valid, rule);
                  } else if (method === 'display') {
                    this.api.display(valid, rule);
                  } else if (method === 'required') {
                    rule.forEach(item => {
                      this.api.setEffect(item, 'required', valid);
                    });
                    if (!valid) {
                      this.api.clearValidateState(rule);
                    }
                  } else {
                    this.api.hidden(!valid, rule);
                  }
                });
                return;
              }
              if (valid) {
                flag = true;
                const ruleCon = {
                  type: 'fcFragment',
                  native: true,
                  __ctrl: true,
                  children: rule
                };
                ctx.ctrlRule.push(ruleCon);
                this.bus.$once('load-start', () => {
                  if (prepend) {
                    api.prepend(ruleCon, prepend, child);
                  } else if (append || child) {
                    api.append(ruleCon, append || ctx.id, child);
                  } else {
                    ctx.root.splice(ctx.root.indexOf(ctx.origin) + 1, 0, ruleCon);
                  }
                });
              } else {
                ctx.ctrlRule.splice(ctx.ctrlRule.indexOf(ctrl), 1);
                const ctrlCtx = byCtx(ctrl);
                ctrlCtx && ctrlCtx.rm();
              }
            });
          });
          hideLst.length && this.vm.$nextTick(() => {
            hideLst.forEach(v => v());
          });
          this.vm.$emit('control', ctx.origin, this.api);
          this.effect(ctx, 'control');
          return flag;
        },
        reloadRule(rules) {
          return this._reloadRule(rules);
        },
        _reloadRule(rules) {
          if (!rules) rules = this.rules;
          const ctxs = {
            ...this.ctxs
          };
          this.clearNextTick();
          this.$render.clearOrgChildren();
          this.initData(rules);
          this.fc.rules = rules;
          this.deferSyncValue(() => {
            this.bus.$once('load-end', () => {
              Object.keys(ctxs).filter(id => this.ctxs[id] === undefined).forEach(id => this.rmCtx(ctxs[id]));
              this.$render.clearCacheAll();
            });
            this.reloading = true;
            this.loadRule();
            this.reloading = false;
            this.refresh();
            this.vm.$emit('reloading', this.api);
          });
          this.bus.$off('next-tick', this.nextReload);
          this.bus.$once('next-tick', this.nextReload);
          this.vm.$emit('update', this.api);
        },
        refresh() {
          this.vm._refresh();
        }
      });
    }
    function fullRule(rule) {
      const def = baseRule();
      Object.keys(def).forEach(k => {
        if (!hasProperty(rule, k)) $set(rule, k, def[k]);
      });
      return rule;
    }
    function getCtrl(ctx) {
      const control = ctx.rule.control || [];
      if (is.Object(control)) return [control];else return control;
    }
    function findCtrl(ctx, rule) {
      for (let i = 0; i < ctx.ctrlRule.length; i++) {
        const ctrl = ctx.ctrlRule[i];
        if (ctrl.children === rule) return ctrl;
      }
    }
    function isCtrl(ctx) {
      return !!ctx.rule.__ctrl;
    }

    function useInput(Handler) {
      extend(Handler.prototype, {
        getValue(ctx) {
          if (is.Undef(ctx.cacheValue)) {
            ctx.cacheValue = ctx.parser.toValue(this.getFormData(ctx), ctx);
          }
          return ctx.cacheValue;
        },
        setValue(ctx, value, formValue, setFlag) {
          if (ctx.deleted) return;
          let newValue = value;
          if (ctx.type === 'select' && !Array.isArray(value)) {
            newValue = [value];
          }
          ctx.cacheValue = newValue;
          this.changeStatus = true;
          this.nextRefresh();
          this.$render.clearCache(ctx);
          this.setFormData(ctx, formValue);
          this.syncValue();
          this.valueChange(ctx, newValue);
          this.vm.$emit('change', ctx.field, value, ctx.origin, this.api, setFlag || false);
          this.effect(ctx, 'value');
        },
        onInput(ctx, value) {
          let val;
          if (ctx.input && (this.isQuote(ctx, val = ctx.parser.toValue(value, ctx)) || this.isChange(ctx, val))) {
            this.setValue(ctx, val, value);
          }
        },
        setFormData(ctx, value) {
          $set(this.formData, ctx.id, value === null ? undefined : value);
        },
        getFormData(ctx) {
          return this.formData[ctx.id];
        },
        validate() {
          toEmpty(this.vm.validate);
          this.fields().forEach(id => {
            this.fieldCtx[id].forEach(ctx => {
              this.vm.validate[ctx.id] = toArray(ctx.rule.validate);
            });
          });
          return this.vm.validate;
        },
        syncForm() {
          toEmpty(this.form);
          Object.defineProperties(this.form, this.fields().reduce((initial, field) => {
            const ctx = this.getFieldCtx(field);
            const handle = this.valueHandle(ctx);
            handle.configurable = true;
            initial[field] = handle;
            return initial;
          }, this.options.appendValue ? Object.keys(this.appendData).reduce((initial, field) => {
            initial[field] = {
              enumerable: true,
              configurable: true,
              get: () => {
                return this.appendData[field];
              },
              set: val => {
                this.appendData[field] = val;
              }
            };
            return initial;
          }, {}) : {}));
          this.syncValue();
        },
        valueHandle(ctx) {
          return {
            enumerable: true,
            get: () => {
              return this.getValue(ctx);
            },
            set: value => {
              if (this.isChange(ctx, value)) {
                this.setValue(ctx, value, ctx.parser.toFormValue(value, ctx), true);
              }
            }
          };
        },
        appendValue(rule) {
          if (!rule.field || !hasProperty(this.appendData, rule.field)) return;
          rule.value = this.appendData[rule.field];
          delete this.appendData[rule.field];
        },
        addSubForm(ctx, subForm) {
          this.subForm[ctx.id] = subForm;
        },
        deferSyncValue(fn, sync) {
          if (!this.deferSyncFn) {
            this.deferSyncFn = fn;
          }
          if (!this.deferSyncFn.sync) {
            this.deferSyncFn.sync = sync;
          }
          invoke(fn);
          if (this.deferSyncFn === fn) {
            this.deferSyncFn = null;
            if (fn.sync) {
              this.syncValue();
            }
          }
        },
        syncValue() {
          if (this.deferSyncFn) {
            return this.deferSyncFn.sync = true;
          }
          this.vm._updateValue({
            ...(this.options.appendValue ? this.appendData : {}),
            ...this.form
          });
        },
        isChange(ctx, value) {
          return JSON.stringify(ctx.rule.value, strFn) !== JSON.stringify(value === null ? undefined : value, strFn);
        },
        isQuote(ctx, value) {
          return (is.Object(value) || Array.isArray(value)) && value === ctx.rule.value;
        },
        refreshUpdate(ctx, val) {
          if (is.Function(ctx.rule.update)) {
            const state = invoke(() => ctx.rule.update(val, ctx.origin, this.api));
            if (state === undefined) return;
            ctx.rule.hidden = state === true;
          }
        },
        valueChange(ctx, val) {
          this.refreshRule(ctx, val);
          this.bus.$emit('change-' + ctx.field, val);
        },
        refreshRule(ctx, val) {
          if (this.refreshControl(ctx)) {
            this.$render.clearCacheAll();
            this.loadRule();
            this.vm.$emit('update', this.api);
            this.refresh();
          }
          this.refreshUpdate(ctx, val);
        },
        appendLink(ctx) {
          const link = ctx.rule.link;
          is.trueArray(link) && link.forEach(field => {
            const fn = () => this.refreshRule(ctx, ctx.rule.value);
            this.bus.$on('change-' + field, fn);
            ctx.linkOn.push(() => this.bus.$off('change-' + field, fn));
          });
        },
        fields() {
          return Object.keys(this.fieldCtx);
        }
      });
    }
    function strFn(key, val) {
      return typeof val === 'function' ? '' + val : val;
    }
    function toEmpty(obj) {
      Object.keys(obj).forEach(k => delete obj[k]);
    }

    const BaseParser = {
      init(ctx) {},
      toFormValue(value, ctx) {
        return value;
      },
      toValue(formValue, ctx) {
        return formValue;
      },
      mounted(ctx) {},
      render(children, ctx) {
        return ctx.$render.defaultRender(ctx, children);
      },
      preview(children, ctx) {
        return this.render(children, ctx);
      },
      mergeProp(ctx) {}
    };

    const noneKey = ['field', 'value', 'vm', 'template', 'name', 'config', 'control', 'inject', 'sync', 'payload', 'optionsTo', 'update', 'component', 'cache'];
    function useContext(Handler) {
      extend(Handler.prototype, {
        getCtx(id) {
          return this.getFieldCtx(id) || this.getNameCtx(id)[0] || this.ctxs[id];
        },
        getCtxs(id) {
          return this.fieldCtx[id] || this.nameCtx[id] || (this.ctxs[id] ? [this.ctxs[id]] : []);
        },
        setIdCtx(ctx, key, type) {
          const field = `${type}Ctx`;
          if (!this[field][key]) {
            this[field][key] = [ctx];
          } else {
            this[field][key].push(ctx);
          }
        },
        rmIdCtx(ctx, key, type) {
          const field = `${type}Ctx`;
          const lst = this[field][key];
          if (!lst) return false;
          const flag = lst.splice(lst.indexOf(ctx) >>> 0, 1).length > 0;
          if (!lst.length) {
            delete this[field][key];
          }
          return flag;
        },
        getFieldCtx(field) {
          return (this.fieldCtx[field] || [])[0];
        },
        getNameCtx(name) {
          return this.nameCtx[name] || [];
        },
        setCtx(ctx) {
          let {
            id,
            field,
            name,
            rule
          } = ctx;
          this.ctxs[id] = ctx;
          name && this.setIdCtx(ctx, name, 'name');
          if (!ctx.input) return;
          this.setIdCtx(ctx, field, 'field');
          this.setFormData(ctx, ctx.parser.toFormValue(rule.value, ctx));
          if (this.isMounted && !this.reloading) {
            this.vm.$emit('change', ctx.field, rule.value, ctx.origin, this.api);
          }
        },
        getParser(ctx) {
          const list = this.fc.parsers;
          return list[ctx.originType] || list[toCase(ctx.type)] || list[ctx.trueType] || BaseParser;
        },
        bindParser(ctx) {
          ctx.setParser(this.getParser(ctx));
        },
        getType(alias) {
          const map = this.fc.CreateNode.aliasMap;
          const type = map[alias] || map[toCase(alias)] || alias;
          return toCase(type);
        },
        noWatch(fn) {
          if (!this.noWatchFn) {
            this.noWatchFn = fn;
          }
          invoke(fn);
          if (this.noWatchFn === fn) {
            this.noWatchFn = null;
          }
        },
        watchCtx(ctx) {
          const vm = this.vm;
          Object.keys(ctx.rule).filter(k => k[0] !== '_' && k[0] !== '$' && noneKey.indexOf(k) === -1).forEach(key => {
            const flag = key === 'children';
            ctx.watch.push(vm.$watch(() => ctx.rule[key], (n, o) => {
              if (this.loading || this.noWatchFn || this.reloading) return;
              if (flag && ctx.parser.loadChildren === false) {
                this.$render.clearCache(ctx);
                this.nextRefresh();
                return;
              }
              this.watching = true;
              if (key === 'link') {
                ctx.link();
                return;
              } else if (['props', 'on', 'nativeOn', 'deep'].indexOf(key) > -1) {
                this.parseInjectEvent(ctx.rule, n || {});
                if (key === 'props' && ctx.input) {
                  this.setFormData(ctx, ctx.parser.toFormValue(ctx.rule.value, ctx));
                }
              } else if (['emit', 'nativeEmit'].indexOf(key) > -1) this.parseEmit(ctx, key === 'emit');else if (['prefix', 'suffix'].indexOf(key) > -1) n && this.loadFn(n, ctx.rule);else if (key === 'type') {
                ctx.updateType();
                this.bindParser(ctx);
              } else if (key === 'children') {
                const flag = is.trueArray(n);
                this.deferSyncValue(() => {
                  if (n !== o) {
                    this.rmSub(o, ctx);
                    this.$render.initOrgChildren();
                  }
                  flag && this.loadChildren(n, ctx);
                  this.vm.$emit('update', this.api);
                });
              }
              this.$render.clearCache(ctx);
              this.refresh();
              this.watching = false;
            }, {
              deep: !flag,
              sync: flag
            }));
          });
          this.watchEffect(ctx);
        },
        rmSub(sub, ctx) {
          is.trueArray(sub) && sub.forEach(r => {
            r && r.__fc__ && r.__fc__.parent === ctx && this.rmCtx(r.__fc__);
          });
        },
        rmCtx(ctx) {
          if (ctx.deleted) return;
          const {
            id,
            field,
            input,
            name
          } = ctx;
          if (ctx.input) {
            Object.defineProperty(ctx.rule, 'value', {
              value: ctx.rule.value,
              writable: true
            });
          }
          $del(this.ctxs, id);
          $del(this.$render.tempList, id);
          $del(this.$render.orgChildren, id);
          $del(this.vm.ctxInject, id);
          $del(this.formData, id);
          $del(this.subForm, id);
          $del(ctx, 'cacheValue');
          input && this.rmIdCtx(ctx, field, 'field');
          name && this.rmIdCtx(ctx, name, 'name');
          if (input && !hasProperty(this.fieldCtx, field)) {
            $del(this.form, field);
          }
          this.deferSyncValue(() => {
            if (!this.reloading) {
              if (ctx.parser.loadChildren !== false) {
                if (is.trueArray(ctx.rule.children)) {
                  ctx.rule.children.forEach(h => h.__fc__ && this.rmCtx(h.__fc__));
                }
              }
              if (ctx.root === this.rules) {
                this.vm._renderRule();
              }
            }
          }, input);
          const index = this.sort.indexOf(id);
          if (index > -1) {
            this.sort.splice(index, 1);
          }
          this.$render.clearCache(ctx);
          ctx.delete();
          this.effect(ctx, 'deleted');
          input && !this.fieldCtx[field] && this.vm.$emit('removeField', field, ctx.rule, this.api);
          ctx.rule.__ctrl || this.vm.$emit('removeRule', ctx.rule, this.api);
          return ctx;
        }
      });
    }

    function useLifecycle(Handler) {
      extend(Handler.prototype, {
        mounted() {
          const _mounted = () => {
            this.isMounted = true;
            this.lifecycle('mounted');
          };
          if (this.pageEnd) {
            _mounted();
          } else {
            this.bus.$once('page-end', _mounted);
          }
        },
        lifecycle(name) {
          const fn = this.options[name];
          is.Function(fn) && invoke(() => fn(this.api));
          this.vm.$emit(name, this.api);
        }
      });
    }

    function useEffect(Handler) {
      extend(Handler.prototype, {
        useProvider() {
          const ps = this.fc.providers;
          Object.keys(ps).forEach(k => {
            let prop = ps[k];
            if (is.Function(prop)) {
              prop = prop(this.fc);
            }
            prop._c = getComponent(prop);
            this.onEffect(prop);
            this.providers[k] = prop;
          });
        },
        onEffect(provider) {
          const used = [];
          (provider._c || ['*']).forEach(name => {
            const type = name === '*' ? '*' : this.getType(name);
            if (used.indexOf(type) > -1) return;
            used.push(type);
            this.bus.$on(`p:${provider.name}:${type}:${provider.input ? 1 : 0}`, (event, args) => {
              provider[event] && provider[event](...args);
            });
          });
          provider._used = used;
        },
        watchEffect(ctx) {
          const vm = this.vm;
          let effect = {
            required: () => {
              var _ctx$rule, _ctx$rule$effect;
              return (hasProperty(ctx.rule, '$required') ? ctx.rule['$required'] : (_ctx$rule = ctx.rule) === null || _ctx$rule === void 0 ? void 0 : (_ctx$rule$effect = _ctx$rule.effect) === null || _ctx$rule$effect === void 0 ? void 0 : _ctx$rule$effect.required) || false;
            }
          };
          Object.keys(ctx.rule.effect || {}).forEach(k => {
            effect[k] = () => ctx.rule.effect[k];
          });
          Object.keys(ctx.rule).forEach(k => {
            if (k[0] === '$') {
              effect[k.substr(1)] = () => ctx.rule[k];
            }
          });
          Object.keys(effect || {}).forEach(k => {
            ctx.watch.push(vm.$watch(effect[k], n => {
              this.effect(ctx, 'watch', {
                [k]: n
              });
            }, {
              deep: true
            }));
          });
        },
        ruleEffect(rule, event, append) {
          this.emitEffect({
            rule,
            input: !!rule.field,
            type: this.getType(rule.type)
          }, event, append);
        },
        effect(ctx, event, custom) {
          this.emitEffect({
            rule: ctx.rule,
            input: ctx.input,
            type: ctx.trueType,
            ctx,
            custom
          }, event);
        },
        getEffect(rule, name) {
          if (hasProperty(rule, '$' + name)) {
            return rule['$' + name];
          }
          if (hasProperty(rule, 'effect') && hasProperty(rule.effect, name)) return rule.effect[name];
          return undefined;
        },
        emitEffect({
          ctx,
          rule,
          input,
          type,
          custom
        }, event, append) {
          if (!type || type === 'fcFragment') return;
          const effect = custom ? custom : Object.keys(rule).reduce((i, k) => {
            if (k[0] === '$') {
              i[k.substr(1)] = rule[k];
            }
            return i;
          }, {
            ...(rule.effect || {})
          });
          Object.keys(effect).forEach(attr => {
            const p = this.providers[attr];
            if (!p || p.input && !input) return;
            let _type;
            if (!p._c) {
              _type = '*';
            } else if (p._used.indexOf(type) > -1) {
              _type = type;
            } else {
              return;
            }
            const data = {
              value: effect[attr],
              getValue: () => this.getEffect(rule, attr),
              ...(append || {})
            };
            if (ctx) {
              data.getProp = () => ctx.effectData(attr);
              data.clearProp = () => ctx.clearEffectData(attr);
              data.mergeProp = prop => mergeRule(data.getProp(), [prop]);
            }
            this.bus.$emit(`p:${attr}:${_type}:${p.input ? 1 : 0}`, event, [data, rule, this.api]);
          });
        }
      });
    }
    function unique(arr) {
      return arr.filter(function (item, index, arr) {
        return arr.indexOf(item, 0) === index;
      });
    }
    function getComponent(p) {
      const c = p.components;
      if (Array.isArray(c)) return unique(c.filter(v => v !== '*'));else if (is.String(c)) return [c];else return false;
    }

    function Handler(fc) {
      extend(this, {
        fc,
        vm: fc.vm,
        watching: false,
        loading: false,
        reloading: false,
        noWatchFn: null,
        deferSyncFn: null,
        isMounted: false,
        formData: {},
        subForm: {},
        form: {},
        appendData: {},
        providers: {},
        cycleLoad: null,
        loadedId: 1,
        nextTick: null,
        changeStatus: false,
        pageEnd: true,
        nextReload: () => {
          this.lifecycle('reload');
        }
      });
      funcProxy(this, {
        options() {
          return fc.options;
        },
        bus() {
          return fc.bus;
        }
      });
      this.initData(fc.rules);
      this.$manager = new fc.manager(this);
      this.$render = new Render(this);
      this.api = fc.extendApi(Api(this), this);
    }
    extend(Handler.prototype, {
      initData(rules) {
        extend(this, {
          ctxs: {},
          fieldCtx: {},
          nameCtx: {},
          sort: [],
          rules
        });
      },
      init() {
        this.appendData = {
          ...(this.fc.options.formData || {}),
          ...(this.vm.value || {}),
          ...this.appendData
        };
        this.useProvider();
        this.usePage();
        this.loadRule();
        this.$manager.__init();
        this.vm.$set(this.vm, 'formData', this.formData);
      }
    });
    useInject(Handler);
    usePage(Handler);
    useRender$1(Handler);
    useLoader(Handler);
    useInput(Handler);
    useContext(Handler);
    useLifecycle(Handler);
    useEffect(Handler);

    function getError(action, option, xhr) {
      const msg = `fail to ${action} ${xhr.status}'`;
      const err = new Error(msg);
      err.status = xhr.status;
      err.url = action;
      return err;
    }
    function getBody(xhr) {
      const text = xhr.responseText || xhr.response;
      if (!text) {
        return text;
      }
      try {
        return JSON.parse(text);
      } catch (e) {
        return text;
      }
    }
    function fetch(option) {
      if (typeof XMLHttpRequest === 'undefined') {
        return;
      }
      const xhr = new XMLHttpRequest();
      const action = option.action;
      xhr.onerror = function error(e) {
        option.onError(e);
      };
      xhr.onload = function onload() {
        if (xhr.status < 200 || xhr.status >= 300) {
          return option.onError(getError(action, option, xhr), getBody(xhr));
        }
        option.onSuccess(getBody(xhr));
      };
      xhr.open(option.method || 'get', action, true);
      let formData;
      if (option.data) {
        if ((option.dataType || '').toLowerCase() !== 'json') {
          formData = new FormData();
          Object.keys(option.data).map(key => {
            formData.append(key, option.data[key]);
          });
        } else {
          formData = JSON.stringify(option.data);
          xhr.setRequestHeader('content-type', 'application/json');
        }
      }
      if (option.withCredentials && 'withCredentials' in xhr) {
        xhr.withCredentials = true;
      }
      const headers = option.headers || {};
      Object.keys(headers).forEach(item => {
        if (headers[item] !== null) {
          xhr.setRequestHeader(item, headers[item]);
        }
      });
      xhr.send(formData);
    }

    const NAME$9 = 'fcFragment';
    var fragment = {
      name: NAME$9,
      functional: true,
      props: ['vnode'],
      render(h, ctx) {
        return ctx.props.vnode ? ctx.props.vnode : ctx.children;
      }
    };

    function parseProp(prop) {
      if (is.String(prop)) return {
        domProps: {
          innerHTML: prop
        }
      };
      return prop;
    }
    function CreateNodeFactory() {
      const aliasMap = {};
      function CreateNode(vm) {
        vm && this.setVm(vm);
      }
      extend(CreateNode.prototype, {
        setVm(vm) {
          this.vm = vm;
          this.$h = vm.$createElement;
        },
        make(tag, data, children) {
          if (Vue.config.isReservedTag(tag) && data.nativeOn) delete data.nativeOn;
          return this.makeComponent(tag, data, children);
        },
        makeComponent(type, data, children) {
          let Node = this.$h(type, parseProp(data), children || []);
          Node.context = this.vm;
          return Node;
        },
        aliasMap
      });
      extend(CreateNode, {
        aliasMap,
        alias(alias, name) {
          aliasMap[alias] = name;
        },
        use(nodes) {
          Object.keys(nodes).forEach(k => {
            const line = toLine(k);
            const lower = toString(k).toLocaleLowerCase();
            const v = nodes[k];
            [k, line, lower].forEach(n => {
              CreateNode.alias(k, v);
              CreateNode.prototype[n] = function (data, children) {
                return this.make(v, data, children);
              };
            });
          });
        }
      });
      return CreateNode;
    }

    function createManager(proto) {
      class CustomManager extends Manager {}
      Object.assign(CustomManager.prototype, proto);
      return CustomManager;
    }
    function Manager(handler) {
      extend(this, {
        $handle: handler,
        vm: handler.vm,
        options: {},
        ref: 'fcForm',
        mergeOptionsRule: {
          normal: ['form', 'row', 'info', 'submitBtn', 'resetBtn']
        }
      });
      this.updateKey();
      this.init();
    }
    extend(Manager.prototype, {
      __init() {
        this.$render = this.$handle.$render;
        this.$r = (...args) => this.$render.renderRule(...args);
      },
      updateKey() {
        this.key = uniqueId();
      },
      init() {},
      update() {},
      beforeRender() {},
      form() {
        return this.vm.$refs[this.ref];
      },
      mergeOptions(args, opt) {
        return mergeProps(args.map(v => this.tidyOptions(v)), opt, this.mergeOptionsRule);
      },
      updateOptions(options) {
        this.options = this.mergeOptions([options], this.getDefaultOptions());
        this.update();
      },
      tidyOptions(options) {
        return options;
      },
      tidyRule(ctx) {},
      mergeProp(ctx) {},
      getDefaultOptions() {
        return {};
      },
      render(children) {}
    });

    const fetch$1 = function (fc) {
      function parseOpt(option) {
        if (is.String(option)) {
          option = {
            action: option,
            to: 'options'
          };
        }
        return option;
      }
      function run(inject, rule, api) {
        let option = inject.value;
        if (is.Function(option)) {
          option = option(rule, api);
        }
        option = parseOpt(option);
        if (!option || !option.action) {
          return false;
        }
        if (!option.to) {
          option.to = 'options';
        }
        const onError = option.onError;
        const check = () => {
          if (!inject.getValue()) {
            inject.clearProp();
            api.sync(rule);
            return true;
          }
        };
        const set = val => {
          if (val === undefined) {
            inject.clearProp();
            api.sync(rule);
          } else {
            deepSet(inject.getProp(), option.to, val);
          }
        };
        invoke(() => fc.create.fetch({
          ...option,
          onSuccess(body) {
            if (check()) return;
            let fn = v => v.data;
            if (is.Function(option.parse)) {
              fn = option.parse;
            }
            set(fn(body, rule, api));
            api.sync(rule);
          },
          onError(e) {
            set(undefined);
            if (check()) return;
            (onError || (e => err(e.message || 'fetch fail ' + option.action)))(e, rule, api);
          }
        }, {
          inject,
          rule,
          api
        }));
        return true;
      }
      return {
        name: 'fetch',
        loaded(...args) {
          run(...args);
        },
        watch(inject, rule, api) {
          if (!run(inject, rule, api)) {
            inject.clearProp();
            api.sync(rule);
          }
        }
      };
    };
    const $required = {
      name: 'required',
      load(inject, rule, api) {
        const val = parseVal(inject.getValue());
        if (val.required === false) {
          inject.clearProp();
        } else {
          const validate = {
            required: true,
            validator(_, v, call) {
              is.empty(v) ? call(validate.message) : call();
            },
            ...val
          };
          if (!validate.message) {
            let title = rule.title || '';
            validate.message = ((typeof title === 'object' ? title.title : title) || '') + '不能为空';
          }
          inject.getProp().validate = [validate];
        }
        api.sync(rule);
      },
      watch(...args) {
        $required.load(...args);
      }
    };
    function parseVal(val) {
      if (is.Boolean(val)) {
        return {
          required: val
        };
      } else if (is.String(val)) {
        return {
          message: val
        };
      } else if (is.Undef(val)) {
        return {
          required: false
        };
      } else if (is.Function(val)) {
        return {
          validator: val
        };
      } else if (!is.Object(val)) {
        return {};
      } else {
        return val;
      }
    }
    var $provider = {
      fetch: fetch$1,
      required: $required
    };

    const name = 'html';
    var html = {
      name,
      loadChildren: false,
      render(children, ctx) {
        if (!ctx.prop.domProps) ctx.prop.domProps = {};
        ctx.prop.domProps.innerHTML = children;
        return ctx.vNode.make(ctx.prop.props.tag || 'div', ctx.prop);
      },
      renderChildren(ctx) {
        if (Array.isArray(ctx.rule.children)) {
          return ctx.rule.children.filter(v => is.String(v)).join('');
        }
        return '';
      }
    };

    let _vue = typeof window !== 'undefined' && window.Vue ? window.Vue : Vue;
    function _parseProp(name, id) {
      let prop;
      if (arguments.length === 2) {
        prop = arguments[1];
        id = prop[name];
      } else {
        prop = arguments[2];
      }
      return {
        id,
        prop
      };
    }
    function nameProp() {
      return _parseProp('name', ...arguments);
    }
    function _getEl(options) {
      if (!options || !options.el) return window.document.body;
      return is.Element(options.el) ? options.el : document.querySelector(options.el);
    }
    function mountForm(rules, option) {
      const $vm = new _vue({
        data() {
          return {
            rule: rules,
            option: option || {}
          };
        },
        render(h) {
          return h('FormCreate', {
            ref: 'fc',
            props: this.$data
          });
        }
      });
      $vm.$mount();
      return $vm;
    }
    function exportAttrs(attrs) {
      const key = attrs.key || [];
      const array = attrs.array || [];
      const normal = attrs.normal || [];
      keyAttrs.push(...key);
      arrayAttrs.push(...array);
      normalAttrs.push(...normal);
      appendProto([...key, ...array, ...normal]);
    }
    let id$1 = 1;
    const instance = {};
    function FormCreateFactory(config) {
      const components = {
        [fragment.name]: fragment
      };
      const parsers = {};
      const directives = {};
      const providers = {
        ...$provider
      };
      const maker = makerFactory();
      let globalConfig = {
        global: {}
      };
      const data = {};
      const CreateNode = CreateNodeFactory();
      exportAttrs(config.attrs || {});
      function getApi(name) {
        const val = instance[name];
        if (Array.isArray(val)) return [...val];
        return val;
      }
      function directive() {
        const data = nameProp(...arguments);
        if (data.id && data.prop) directives[data.id] = data.prop;
      }
      function register() {
        const data = nameProp(...arguments);
        if (data.id && data.prop) providers[data.id] = {
          ...data.prop,
          name: data.id
        };
      }
      function componentAlias(alias) {
        CreateNode.use(alias);
      }
      function parser() {
        const data = nameProp(...arguments);
        if (!data.id || !data.prop) return;
        const name = toCase(data.id);
        const parser = data.prop;
        const base = parser.merge === true ? parsers[name] : undefined;
        parsers[name] = {
          ...(base || BaseParser),
          ...parser
        };
        maker[name] = creatorFactory(name);
        parser.maker && extend(maker, parser.maker);
      }
      function component(id, component) {
        let name;
        if (is.String(id)) {
          name = toCase(id);
          if (['form-create', 'formcreate'].indexOf(name) > -1) {
            return $form();
          } else if (component === undefined) {
            return components[name];
          }
        } else {
          name = toCase(id.name);
          component = id;
        }
        if (!name || !component) return;
        components[name] = component;
        if (component.formCreateParser) parser(name, component.formCreateParser);
      }
      function $form() {
        return _vue.extend($FormCreate(FormCreate));
      }
      function $vnode() {
        return _vue.extend(fragment);
      }
      function use(fn, opt) {
        if (is.Function(fn.install)) fn.install(create, opt);else if (is.Function(fn)) fn(create, opt);
        return this;
      }
      function create(rules, _opt, parent) {
        let $vm = mountForm(rules, _opt || {});
        const _this = $vm.$refs.fc.formCreate;
        _this.$parent = parent;
        _getEl(_this.options).appendChild($vm.$el);
        return _this.api();
      }
      function factory(inherit) {
        let _config = {
          ...config
        };
        if (inherit) {
          _config.inherit = {
            components,
            parsers,
            directives,
            providers,
            maker,
            data
          };
        } else {
          delete _config.inherit;
        }
        return FormCreateFactory(_config);
      }
      function FormCreate(vm, rules, options) {
        extend(this, {
          id: id$1++,
          vm,
          create,
          manager: createManager(config.manager),
          parsers,
          providers,
          rules: Array.isArray(rules) ? rules : [],
          name: vm.$options.propsData.name,
          inFor: vm.$options.propsData.inFor,
          prop: {
            components,
            directives
          },
          CreateNode,
          bus: new _vue(),
          unwatch: null,
          options: options || {},
          extendApi: config.extendApi || (api => api)
        });
        this.init();
        this.initOptions(this.options);
        if (this.name) {
          if (this.inFor) {
            if (!instance[this.name]) instance[this.name] = [];
            instance[this.name].push(this.api());
          } else {
            instance[this.name] = this.api();
          }
        }
      }
      extend(FormCreate.prototype, {
        init() {
          const vm = this.vm;
          const h = new Handler(this);
          this.$handle = h;
          vm.$f = h.api;
          vm.$emit('input', h.api);
          vm.$on('hook:created', () => {
            if (this.isSub()) {
              this.unwatch = vm.$watch(() => vm.$pfc.option, () => {
                this.initOptions(this.options);
                vm.$f.refresh();
              }, {
                deep: true
              });
              this.initOptions(this.options);
            }
            this.created();
          });
          vm.$on('hook:mounted', () => {
            this.mounted();
          });
          vm.$on('hook:beforeDestroy', () => {
            vm.destroyed = true;
            this.unwatch && this.unwatch();
            h.reloadRule([]);
            if (this.name) {
              if (this.inFor) {
                const idx = instance[this.name].indexOf(this.api());
                instance[this.name].splice(idx, 1);
              } else {
                delete instance[this.name];
              }
            }
          });
          vm.$on('hook:updated', () => {
            h.bindNextTick(() => this.bus.$emit('next-tick', h.api));
          });
        },
        isSub() {
          return this.vm.$pfc && this.vm.extendOption;
        },
        initOptions(options) {
          this.options = {
            formData: {},
            submitBtn: {},
            resetBtn: {},
            ...deepCopy(globalConfig)
          };
          if (this.isSub()) {
            this.mergeOptions(this.options, this.vm.$pfc.$f.config || {}, true);
          }
          this.updateOptions(options);
        },
        mergeOptions(target, opt, parent) {
          opt = deepCopy(opt);
          parent && ['page', 'onSubmit', 'mounted', 'reload', 'formData', 'el'].forEach(n => {
            delete opt[n];
          });
          if (opt.global) {
            target.global = mergeGlobal(target.global, opt.global);
            delete opt.global;
          }
          this.$handle.$manager.mergeOptions([opt], target);
          return target;
        },
        updateOptions(options) {
          this.mergeOptions(this.options, options);
          this.$handle.$manager.updateOptions(this.options);
        },
        created() {
          this.$handle.init();
          this.vm.$emit('created', this.api());
        },
        api() {
          return this.$handle.api;
        },
        render() {
          return this.$handle.render();
        },
        mounted() {
          this.$handle.mounted();
        }
      });
      function useAttr(formCreate) {
        extend(formCreate, {
          version: config.version,
          ui: config.ui,
          data,
          maker,
          component,
          directive,
          register,
          $vnode,
          parser,
          use,
          factory,
          componentAlias,
          copyRule,
          copyRules,
          fetch,
          $form,
          parseFn,
          parseJson,
          toJson,
          getApi,
          init(rules, _opt = {}) {
            let $vm = mountForm(rules, _opt),
              _this = $vm.$refs.fc.formCreate;
            return {
              mount($el) {
                if ($el && is.Element($el)) _this.options.el = $el;
                _getEl(_this.options).appendChild($vm.$el);
                return _this.api();
              },
              remove() {
                $vm.$el.parentNode && $vm.$el.parentNode.removeChild($vm.$el);
              },
              destroy() {
                this.remove();
                $vm.$destroy();
              },
              $f: _this.api()
            };
          }
        });
      }
      function useStatic(formCreate) {
        extend(formCreate, {
          create,
          install(Vue, options) {
            globalConfig = {
              ...globalConfig,
              ...(options || {})
            };
            if (Vue._installedFormCreate === true) return;
            Vue._installedFormCreate = true;
            _vue = Vue;
            const $formCreate = function (rules, opt = {}) {
              return create(rules, opt, this);
            };
            useAttr($formCreate);
            Vue.prototype.$formCreate = $formCreate;
            Vue.component('FormCreate', $form());
            Vue.component('FcFragment', $vnode());
          }
        });
      }
      useAttr(create);
      useStatic(create);
      CreateNode.use({
        fragment: 'fcFragment'
      });
      parser(html);
      if (config.install) create.use(config);
      if (config.inherit) {
        const inherit = config.inherit;
        inherit.components && extend(components, inherit.components);
        inherit.parsers && extend(parsers, inherit.parsers);
        inherit.directives && extend(directives, inherit.directives);
        inherit.providers && extend(providers, inherit.providers);
        inherit.maker && extend(maker, inherit.maker);
        inherit.data && extend(data, inherit.data);
      }
      return create;
    }

    const DEFAULT_FORMATS = {
      date: 'yyyy-MM-dd',
      month: 'yyyy-MM',
      datetime: 'yyyy-MM-dd HH:mm:ss',
      timerange: 'HH:mm:ss',
      daterange: 'yyyy-MM-dd',
      monthrange: 'yyyy-MM',
      datetimerange: 'yyyy-MM-dd HH:mm:ss',
      year: 'yyyy'
    };
    const name$1 = 'datePicker';
    var datePicker = {
      name: name$1,
      maker: function () {
        return ['year', 'month', 'date', 'dates', 'week', 'datetime', 'datetimeRange', 'dateRange', 'monthRange'].reduce((initial, type) => {
          initial[type] = creatorFactory(name$1, {
            type: type.toLowerCase()
          });
          return initial;
        }, {});
      }(),
      mergeProp(ctx) {
        const props = ctx.prop.props;
        if (!props.valueFormat) {
          props.valueFormat = DEFAULT_FORMATS[props.type] || DEFAULT_FORMATS['date'];
        }
      }
    };

    const name$2 = 'hidden';
    var hidden = {
      name: name$2,
      maker: {
        [name$2]: (field, value) => creatorFactory(name$2)('', field, value)
      },
      render() {
        return [];
      }
    };

    const name$3 = 'input';
    var input = {
      name: name$3,
      maker: function () {
        const maker = ['password', 'url', 'email', 'text', 'textarea'].reduce((maker, type) => {
          maker[type] = creatorFactory(name$3, {
            type
          });
          return maker;
        }, {});
        maker.idate = creatorFactory(name$3, {
          type: 'date'
        });
        return maker;
      }(),
      mergeProp(ctx) {
        let {
          props
        } = ctx.prop;
        if (props && props.autosize && props.autosize.minRows) {
          props.rows = props.autosize.minRows || 2;
        }
      }
    };

    const name$4 = 'slider';
    var slider = {
      name: name$4,
      maker: {
        sliderRange: creatorFactory(name$4, {
          range: true
        })
      },
      toFormValue(value, ctx) {
        let isArr = Array.isArray(value),
          props = ctx.prop.props,
          min = props.min || 0,
          parseValue;
        if (props.range === true) {
          parseValue = isArr ? value : [min, parseFloat(value) || min];
        } else {
          parseValue = isArr ? parseFloat(value[0]) || min : parseFloat(value);
        }
        return parseValue;
      }
    };

    const name$5 = 'timePicker';
    var timePicker = {
      name: name$5,
      maker: {
        time: creatorFactory(name$5, m => m.props.isRange = false),
        timeRange: creatorFactory(name$5, m => m.props.isRange = true)
      },
      mergeProp(ctx) {
        const props = ctx.prop.props;
        if (!props.valueFormat) {
          props.valueFormat = 'HH:mm:ss';
        }
      }
    };

    var row = {
      name: 'FcRow',
      render(_, ctx) {
        return ctx.vNode.col({
          props: {
            span: 24
          }
        }, [ctx.vNode.row(ctx.prop, _)]);
      }
    };

    const name$6 = 'select';
    var select = {
      name: name$6,
      toFormValue(value, ctx) {
        if (ctx.prop.props.multiple) {
          if (!Array.isArray(value)) {
            return toArray(value);
          }
          return value;
        } else {
          if (value) {
            return value[0];
          }
          return [];
        }
      }
    };

    var parsers = [datePicker, hidden, input, slider, timePicker, row, select];

    const PRE = 'el';
    var alias = {
      button: PRE + 'Button',
      icon: 'i',
      slider: PRE + 'Slider',
      rate: PRE + 'Rate',
      upload: 'fcUpload',
      cascader: PRE + 'Cascader',
      popover: PRE + 'Popover',
      tooltip: PRE + 'Tooltip',
      colorPicker: PRE + 'ColorPicker',
      timePicker: PRE + 'TimePicker',
      timeSelect: PRE + 'TimeSelect',
      datePicker: PRE + 'DatePicker',
      'switch': PRE + 'Switch',
      select: 'fcSelect',
      checkbox: 'fcCheckbox',
      radio: 'fcRadio',
      inputNumber: PRE + 'InputNumber',
      number: PRE + 'InputNumber',
      input: PRE + 'Input',
      formItem: PRE + 'FormItem',
      form: PRE + 'Form',
      frame: 'fcFrame',
      col: PRE + 'Col',
      row: PRE + 'Row',
      tree: 'fcTree',
      autoComplete: PRE + 'Autocomplete',
      auto: PRE + 'Autocomplete',
      group: 'fcGroup',
      object: 'fcSubForm',
      subForm: 'fcSubForm'
    };

    function getConfig() {
      return {
        form: {
          inline: false,
          labelPosition: 'right',
          labelWidth: '125px',
          disabled: false,
          size: undefined
        },
        row: {
          show: true,
          gutter: 0
        },
        submitBtn: {
          type: 'primary',
          loading: false,
          disabled: false,
          innerText: '提交',
          show: true,
          col: undefined,
          click: undefined
        },
        resetBtn: {
          type: 'default',
          loading: false,
          disabled: false,
          icon: 'el-icon-refresh',
          innerText: '重置',
          show: false,
          col: undefined,
          click: undefined
        }
      };
    }

    function isTooltip(info) {
      return info.type === 'tooltip';
    }
    const upperCaseReg = /[A-Z]/;
    function isAttr(name, value) {
      return !upperCaseReg.test(name) && (is.String(value) || is.Number(value));
    }
    function tidy(props, name) {
      if (!hasProperty(props, name)) return;
      if (is.String(props[name])) {
        props[name] = {
          [name]: props[name],
          show: true
        };
      }
    }
    function isFalse(val) {
      return val === false;
    }
    function tidyBool(opt, name) {
      if (hasProperty(opt, name) && !is.Object(opt[name])) {
        opt[name] = {
          show: !!opt[name]
        };
      }
    }
    var manager = {
      validate(call) {
        this.form().validate(call);
      },
      validateField(field, call) {
        this.form().validateField(field, call);
      },
      clearValidateState(ctx) {
        const fItem = this.vm.$refs[ctx.wrapRef];
        if (fItem) {
          fItem.validateMessage = '';
          fItem.validateState = '';
        }
      },
      tidyOptions(options) {
        ['submitBtn', 'resetBtn', 'row', 'info', 'wrap', 'col'].forEach(name => {
          tidyBool(options, name);
        });
        return options;
      },
      tidyRule({
        prop
      }) {
        tidy(prop, 'title');
        tidy(prop, 'info');
        return prop;
      },
      mergeProp(ctx) {
        let props = ctx.prop.props;
        ctx.prop = mergeProps([{
          attrs: Object.keys(props).reduce((initial, val) => {
            if (isAttr(val, props[val])) initial[val] = props[val];
            return initial;
          }, {}),
          info: this.options.info || {},
          wrap: this.options.wrap || {},
          col: this.options.col || {}
        }, ctx.prop], {
          info: {
            trigger: 'hover',
            placement: 'top-start',
            icon: 'el-icon-warning'
          },
          title: {},
          col: {
            span: 24
          },
          wrap: {}
        }, {
          normal: ['title', 'info', 'col', 'wrap']
        });
      },
      getDefaultOptions() {
        return getConfig();
      },
      update() {
        const form = this.options.form;
        this.rule = {
          props: {
            ...form
          },
          nativeOn: {
            submit: e => {
              e.preventDefault();
            }
          },
          class: [form.className, form.class, 'form-create'],
          style: form.style,
          type: 'form'
        };
      },
      beforeRender() {
        const {
          key,
          ref,
          $handle
        } = this;
        extend(this.rule, {
          key,
          ref
        });
        extend(this.rule.props, {
          model: $handle.formData,
          rules: $handle.validate()
        });
      },
      render(children) {
        if (children.length) {
          children.push(this.makeFormBtn());
        }
        return this.$r(this.rule, isFalse(this.options.row.show) ? children : [this.makeRow(children)]);
      },
      makeWrap(ctx, children) {
        const rule = ctx.prop;
        const uni = `${this.key}${ctx.key}`;
        const col = rule.col;
        const isTitle = this.isTitle(rule);
        const labelWidth = !col.labelWidth && !isTitle ? 0 : col.labelWidth;
        const {
          inline,
          col: _col
        } = this.rule.props;
        const item = isFalse(rule.wrap.show) ? children : this.$r(mergeProps([rule.wrap, {
          props: {
            labelWidth: labelWidth === void 0 ? labelWidth : toString(labelWidth),
            label: isTitle ? rule.title.title : undefined,
            ...(rule.wrap || {}),
            prop: ctx.id,
            rules: rule.validate
          },
          class: rule.className,
          key: `${uni}fi`,
          ref: ctx.wrapRef,
          type: 'formItem'
        }]), [children, isTitle ? this.makeInfo(rule, uni) : null]);
        return inline === true || isFalse(_col) || isFalse(col.show) ? item : this.makeCol(rule, uni, [item]);
      },
      isTitle(rule) {
        if (this.options.form.title === false) return false;
        const title = rule.title;
        return !(!title.title && !title.native || isFalse(title.show));
      },
      makeInfo(rule, uni) {
        const titleProp = rule.title;
        const infoProp = rule.info;
        const isTip = isTooltip(infoProp);
        const form = this.options.form;
        const children = [(titleProp.title || '') + (form.labelSuffix || form['label-suffix'] || '')];
        if (!isFalse(infoProp.show) && (infoProp.info || infoProp.native) && !isFalse(infoProp.icon)) {
          const prop = {
            type: infoProp.type || 'popover',
            props: {
              ...infoProp
            },
            key: `${uni}pop`,
            slot: 'label'
          };
          const field = 'content';
          if (infoProp.info && !hasProperty(prop.props, field)) {
            prop.props[field] = infoProp.info;
          }
          children[infoProp.align !== 'left' ? 'unshift' : 'push'](this.$r(mergeProps([infoProp, prop]), [this.$r({
            type: 'i',
            slot: isTip ? 'default' : 'reference',
            class: infoProp.icon === true ? 'el-icon-warning' : infoProp.icon,
            key: `${uni}i`
          })]));
        }
        return this.$r(mergeProps([titleProp, {
          props: titleProp,
          slot: titleProp.slot || 'label',
          key: `${uni}tit`,
          type: titleProp.type || 'span'
        }]), children);
      },
      makeCol(rule, uni, children) {
        const col = rule.col;
        return this.$r({
          class: col.class,
          type: 'col',
          props: col || {
            span: 24
          },
          key: `${uni}col`
        }, children);
      },
      makeRow(children) {
        const row = this.options.row || {};
        return this.$r({
          type: 'row',
          props: row,
          class: row.class,
          key: `${this.key}row`
        }, children);
      },
      makeFormBtn() {
        let vn = [];
        if (!isFalse(this.options.submitBtn.show)) {
          vn.push(this.makeSubmitBtn());
        }
        if (!isFalse(this.options.resetBtn.show)) {
          vn.push(this.makeResetBtn());
        }
        if (!vn.length) {
          return;
        }
        const item = this.$r({
          type: 'formItem',
          key: `${this.key}fb`
        }, vn);
        return this.rule.props.inline === true ? item : this.$r({
          type: 'col',
          props: {
            span: 24
          },
          key: `${this.key}fc`
        }, [item]);
      },
      makeResetBtn() {
        const resetBtn = this.options.resetBtn;
        return this.$r({
          type: 'button',
          props: resetBtn,
          style: {
            width: resetBtn.width
          },
          on: {
            click: () => {
              const fApi = this.$handle.api;
              resetBtn.click ? resetBtn.click(fApi) : fApi.resetFields();
            }
          },
          key: `${this.key}b2`
        }, [resetBtn.innerText]);
      },
      makeSubmitBtn() {
        const submitBtn = this.options.submitBtn;
        return this.$r({
          type: 'button',
          props: submitBtn,
          style: {
            width: submitBtn.width
          },
          on: {
            click: () => {
              const fApi = this.$handle.api;
              submitBtn.click ? submitBtn.click(fApi) : fApi.submit();
            }
          },
          key: `${this.key}b1`
        }, [submitBtn.innerText]);
      }
    };

    const maker = {};
    useAlias(maker);
    useSelect(maker);
    useTree(maker);
    useUpload(maker);
    useFrame(maker);
    function useAlias(maker) {
      ['group', 'tree', 'switch', 'upload', 'autoComplete', 'checkbox', 'cascader', 'colorPicker', 'datePicker', 'frame', 'inputNumber', 'radio', 'rate'].forEach(name => {
        maker[name] = creatorFactory(name);
      });
      maker.auto = maker.autoComplete;
      maker.number = maker.inputNumber;
      maker.color = maker.colorPicker;
    }
    function useSelect(maker) {
      const select = 'select';
      const multiple = 'multiple';
      maker['selectMultiple'] = creatorFactory(select, {
        [multiple]: true
      });
      maker['selectOne'] = creatorFactory(select, {
        [multiple]: false
      });
    }
    function useTree(maker) {
      const name = 'tree';
      const types = {
        'treeSelected': 'selected',
        'treeChecked': 'checked'
      };
      Object.keys(types).reduce((m, key) => {
        m[key] = creatorFactory(name, {
          type: types[key]
        });
        return m;
      }, maker);
    }
    function useUpload(maker) {
      const name = 'upload';
      const types = {
        image: ['image', 0],
        file: ['file', 0],
        uploadFileOne: ['file', 1],
        uploadImageOne: ['image', 1]
      };
      Object.keys(types).reduce((m, key) => {
        m[key] = creatorFactory(name, m => m.props({
          uploadType: types[key][0],
          maxLength: types[key][1]
        }));
        return m;
      }, maker);
      maker.uploadImage = maker.image;
      maker.uploadFile = maker.file;
    }
    function useFrame(maker) {
      const types = {
        frameInputs: ['input', 0],
        frameFiles: ['file', 0],
        frameImages: ['image', 0],
        frameInputOne: ['input', 1],
        frameFileOne: ['file', 1],
        frameImageOne: ['image', 1]
      };
      Object.keys(types).reduce((maker, key) => {
        maker[key] = creatorFactory('frame', m => m.props({
          type: types[key][0],
          maxLength: types[key][1]
        }));
        return maker;
      }, maker);
      maker.frameInput = maker.frameInputs;
      maker.frameFile = maker.frameFiles;
      maker.frameImage = maker.frameImages;
      return maker;
    }

    var css_248z$2 = ".form-create .form-create .el-form-item {\n    margin-bottom: 22px;\n}\n\n.form-create .form-create .el-form-item .el-form-item {\n    margin-bottom: 0px;\n}\n";
    styleInject(css_248z$2);

    function tidyBtnProp(btn, def) {
      if (is.Boolean(btn)) btn = {
        show: btn
      };else if (!is.Undef(btn) && !is.Object(btn)) btn = {
        show: def
      };
      return btn;
    }
    function extendApi(api, h) {
      extend(api, {
        validate(callback) {
          let flag;
          const forms = api.children;
          let len = forms.length;
          const validate = () => {
            h.$manager.validate((...args) => {
              if (!args[0] || !flag) {
                flag = args;
              }
              callback && callback(...flag);
            });
          };
          const validFn = args => {
            setTimeout(() => {
              if (!args[0]) {
                if (!flag) {
                  flag = args;
                }
              }
              if (! --len) {
                validate();
              }
            });
          };
          forms.forEach(form => {
            form.validate((...args) => validFn(args));
          });
          if (!len) {
            validate();
          }
        },
        validateField: (field, callback) => {
          const ctx = h.getFieldCtx(field);
          if (!ctx) return;
          const sub = h.subForm[ctx.id];
          let len = 0;
          let flag;
          const validate = () => {
            h.$manager.validateField(ctx.id, (...args) => {
              if (args[0]) {
                flag = args;
              } else if (flag) {
                return callback && callback('子表单验证未通过', flag[1]);
              }
              callback && callback(...(flag || args));
            });
          };
          const validFn = args => {
            setTimeout(() => {
              if (!args[0]) {
                if (!flag) {
                  flag = args;
                }
              }
              if (! --len) {
                validate();
              }
            });
          };
          sub && toArray(sub).forEach(form => {
            len++;
            form.validate((...args) => validFn(args));
          });
          if (!len) {
            validate();
          }
        },
        clearValidateState(fields, clearSub = true) {
          api.helper.tidyFields(fields).forEach(field => {
            if (clearSub) this.clearSubValidateState(field);
            h.getCtxs(field).forEach(ctx => {
              h.$manager.clearValidateState(ctx);
            });
          });
        },
        clearSubValidateState(fields) {
          api.helper.tidyFields(fields).forEach(field => {
            h.getCtxs(field).forEach(ctx => {
              const subForm = h.subForm[ctx.id];
              if (!subForm) return;
              if (Array.isArray(subForm)) {
                subForm.forEach(form => {
                  form.clearValidateState();
                });
              } else if (subForm) {
                subForm.clearValidateState();
              }
            });
          });
        },
        btn: {
          loading: (loading = true) => {
            api.submitBtnProps({
              loading: !!loading
            });
          },
          disabled: (disabled = true) => {
            api.submitBtnProps({
              disabled: !!disabled
            });
          },
          show: (isShow = true) => {
            api.submitBtnProps({
              show: !!isShow
            });
          }
        },
        resetBtn: {
          loading: (loading = true) => {
            api.resetBtnProps({
              loading: !!loading
            });
          },
          disabled: (disabled = true) => {
            api.resetBtnProps({
              disabled: !!disabled
            });
          },
          show: (isShow = true) => {
            api.resetBtnProps({
              show: !!isShow
            });
          }
        },
        submitBtnProps: (props = {}) => {
          let btn = tidyBtnProp(h.options.submitBtn, true);
          extend(btn, props);
          h.options.submitBtn = btn;
          api.refreshOptions();
        },
        resetBtnProps: (props = {}) => {
          let btn = tidyBtnProp(h.options.resetBtn, false);
          extend(btn, props);
          h.options.resetBtn = btn;
          api.refreshOptions();
        },
        submit(successFn, failFn) {
          api.validate(valid => {
            if (valid) {
              let formData = api.formData();
              if (is.Function(successFn)) invoke(() => successFn(formData, this));else {
                is.Function(h.options.onSubmit) && invoke(() => h.options.onSubmit(formData, this));
                h.vm.$emit('submit', formData, this);
              }
            } else {
              is.Function(failFn) && invoke(() => failFn(this, ...arguments));
            }
          });
        }
      });
      return api;
    }

    function install(FormCreate) {
      FormCreate.componentAlias(alias);
      components.forEach(component => {
        FormCreate.component(component.name, component);
      });
      parsers.forEach(parser => {
        FormCreate.parser(parser);
      });
      Object.keys(maker).forEach(name => {
        FormCreate.maker[name] = maker[name];
      });
    }
    function elmFormCreate() {
      return FormCreateFactory({
        ui: `${"element-ui"}`,
        version: `${"2.5.59"}`,
        manager,
        extendApi,
        install,
        attrs: {
          normal: ['col', 'wrap'],
          array: ['className'],
          key: ['title', 'info']
        }
      });
    }

    const FormCreate = elmFormCreate();
    if (typeof window !== 'undefined') {
      window.formCreate = FormCreate;
      if (window.Vue) {
        FormCreate.install(window.Vue);
      }
    }
    const maker$1 = FormCreate.maker;

    exports.default = FormCreate;
    exports.maker = maker$1;

    Object.defineProperty(exports, '__esModule', { value: true });

})));
